/*
SRB2Kart Arcade Mode
AKA Daytona Kart

Made by Aquatic (Lion Sora), Auro (Latius) and LunarRay

Current Version: Version 1.8

Credits to the following:
supercomputer276 for the Wario Land 4 Timer Font
Latius for the custom 7-segment numbers used in the Classic and Wangan HUDs, and for the Wario Land 4 Clock
Afrorule for their Start Boost Helper which has been modified to work with the Daytona HUD
LunarRay and MrNin for improving the Map HELL Time Limits
LunarRay for the new voices and improved time limits for the base maps (Also for some of the music which I added in)
Snu for their Hitfeed mod, which this mod now has intergrations with
Callmore for their HP mod, which this mod now has intergrations with
JuanMXGalarza on DA for the Daytona USA Logo used for the title screen
DanielDapple for their help with the Silver/Gold times
Aquatic for the Pizza Tower timer font
Tyron for the SPBAttack and Splits mods, which this mod now has intergrations with
*/

local version = "V1.8"

freeslot(
"sfx_arccr", "sfx_arclo", "sfx_arcko", "sfx_arcbt",
"sfx_am1lpr", "sfx_am2lpr", "sfx_am5lpr", "sfx_am7lpr",
"sfx_am1lgr", "sfx_am2lgr",
"sfx_amatuw", "sfx_amgoal", "sfx_amlot1", "sfx_amlot2",
"sfx_amsc1", "sfx_amsc2", "sfx_amsc3", "sfx_amscgo",
"sfx_amtex1", "sfx_amtex2", "sfx_amtex3", "sfx_amtex4", "sfx_amtex5",
"sfx_fstbld"
)

local MILESPERHOUR = 1
local KILOMETERSPERHOUR = 2
local NAUTICALMILESPERHOUR = 3
local METERSPERSECOND = 4
local FOOTPERSECOND = 5
local FRACUNITSPERTIC = 6

local TAHUD = -1
local DAYTONAHUD = 1
local WARIOLANDHUD = 2
local BATTLEMANIAHUD = 3
local PIZZATOWERHUD = 4
local WANGANHUD = 5
local LRMAXHUD = 6

local MINERRORMOD = 5
local MAXERRORMOD = 20

//Debug stuff
local dkartdebug = {
	enabled = false,
	hp = 0,
	regen = 0,
	latent = 0
}

local arcadeon = CV_RegisterVar({"arcade", "On", CV_NETVAR|CV_SHOWMODIF, CV_OnOff})

local difficulty = CV_RegisterVar({"arcade_diff", "Normal", CV_NETVAR|CV_SHOWMODIF, {Easiest=30, Easy=15, Normal=0, Hard=-5, Expert=-10, Master=-20, Custom=69}})
local sneakeronly = CV_RegisterVar({"arcade_sneaker", "Off", CV_NETVAR|CV_SHOWMODIF, {Off = 0, On = 1, NoItems = 2, LRMax = 3}})
local sneakerspb = CV_RegisterVar({"arcade_sneakerSPB", "On", CV_NETVAR|CV_SHOWMODIF, {Off = 0, On = 1}})
local customspeedometer = CV_RegisterVar({"arcade_speed", "Miles", CV_SHOWMODIF, {Disabled=0, Miles=MILESPERHOUR, Kilometers=KILOMETERSPERHOUR, Meters=METERSPERSECOND, Fracunits=FRACUNITSPERTIC, Knots=NAUTICALMILESPERHOUR, Feet=FOOTPERSECOND}})
local tenthspeedometer = CV_RegisterVar({"arcade_tenthspeed", "On", CV_SHOWMODIF, CV_OnOff})
local timercap = CV_RegisterVar({"arcade_capto99", "Off", CV_SHOWMODIF, {Off = 0, On = 1, ID = 2, Daytona = 3}})
local leadingzero = CV_RegisterVar({"arcade_placezero", "Off", CV_SHOWMODIF, CV_OnOff})
local instaupdate = CV_RegisterVar({"arcade_instupdate", "On", CV_SHOWMODIF, CV_OnOff})
local hudtype = CV_RegisterVar({"arcade_hud", "BattleMania", CV_SHOWMODIF, {Classic = DAYTONAHUD, WarioLand = WARIOLANDHUD, BattleMania = BATTLEMANIAHUD, PizzaTower = PIZZATOWERHUD, Wangan = WANGANHUD, LunarRayMAX = LRMAXHUD}})
local hpmodtimeover = CV_RegisterVar({"arcade_hpmod_timeover", "On", CV_NETVAR|CV_SHOWMODIF, CV_OnOff})
local timeoverpercent = CV_RegisterVar({"arcade_hpmod_topercent", "Off", CV_NETVAR, CV_OnOff})
local arcadehpbar = CV_RegisterVar({"arcade_hpmod_bar", "On", 0, CV_OnOff})
local compathud = CV_RegisterVar({"arcade_compathud", "Off", CV_NETVAR|CV_SHOWMODIF, {Off = 0, On = 1}})
local preferwanganbar = CV_RegisterVar({"arcade_hpmod_spbar", "Off", 0, CV_OnOff})
local showMaxHP = CV_RegisterVar({"arcade_hpmod_showmax", "Off", 0, CV_OnOff})
local timeoverrate = CV_RegisterVar{
	name = "arcade_hpmod_totic",
	defaultvalue = 10,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 1, MAX = TICRATE}
}
local timeoverdam = CV_RegisterVar{
	name = "arcade_hpmod_torate",
	defaultvalue = 1,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 1, MAX = 100}
}
local timeoverdiffflag = CV_RegisterVar{
	name = "arcade_hpmod_diffmod",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = CV_OnOff
}
local starttimermod = CV_RegisterVar{
	name = "arcade_timermod",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = {MIN = -30, MAX = 60} --Added by LunarRay
}

local laptimermod = CV_RegisterVar{
	name = "arcade_laptimermod",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = {MIN = -20, MAX = 20} --Added by LunarRay
}

local extratimemod = CV_RegisterVar{
	name = "arcade_extratimermod",
	defaultvalue = 8,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 5, MAX = 25}
}

local showdiff = CV_RegisterVar{
	name = "arcade_showdiff",
	defaultvalue = "Off",
	flags = CV_SHOWMODIF,
	PossibleValue = CV_OnOff
}

local battlefirstblood = CV_RegisterVar{
	name = "arcade_battle_firstblood",
	defaultvalue = "Off",
	flags =CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = CV_OnOff
}

local battlefirstbloodtimer = CV_RegisterVar{
	name = "arcade_battle_fbtimer",
	defaultvalue = 90,
	flags =CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = {MIN = 30, MAX = 180}
}

local explosiveKO = CV_RegisterVar{
	name = "arcade_explosiveko",
	defaultvalue = "Off",
	flags =CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = CV_OnOff
}

local lunarRayMAX = CV_RegisterVar{
	name = "arcade_forcelrmax",
	defaultvalue = "Off",
	flags =CV_NETVAR|CV_SHOWMODIF,
	PossibleValue = CV_OnOff
}

local timeoverdiffdefault = {
	[-20] = 4,  //1% damage every 4 Frames
	[-10] = 5,  //1% damage every 5 Frames
	[-5]  = 10, //1% damage every 10 Frames
	[0]   = 17, //1% damage every 17 frames (about 0.5 seconds)
	[15]  = 25, //1% damage every 25 Frames
	[30]  = 35,  //1% damage every second 
	[69]   = 17, //1% damage every 17 frames (about 0.5 seconds)
}

local DIFFSUFF = ({
			[69] = "LOLNOPE",
			[30] = "B+",
			[15] = "B",
			[0] = "S",
			[-5] = "A",
			[-10] = "E",
			[-20] = "M"
})

rawset(_G, "daytonakart", {
	active = arcadeon.value,
	hud = hudtype.value,
	diff = difficulty.value,
	diffsuff = DIFFSUFF[difficulty.value],
	timeover = hpmodtimeover.value,
	topercent = timeoverpercent.value,
	torate = timeoverrate.value,
	todam = timeoverdam.value,
	sneakermode = sneakeronly.value,
	startmod = starttimermod.value,
	lapmod = laptimermod.value,
	extimemod = extratimemod.value,
	maxbumperhealth = 3,
	firstblood = {
		enabled = battlefirstblood.value,
		blooddrawn = false,
		drawntime = 0,
		timelim = battlefirstbloodtimer.value*TICRATE
	},
	lrmax = false,
	explosiveKO = false
})

local FLASHTIME = 5 * TICRATE / 2
local BASETIME = 120
local BASEBONUS = 30
local TIMEOVERLENGTH = 5 * TICRATE

local REDTEXT = 1
local GREENTEXT = 2
local YELLOWTEXT = 3

local TIMEFORTHREE = 26 + (TICRATE * 3)
local TIMEFORTWO = 26 + (TICRATE * 4)
local TIMEFORONE = 26 + (TICRATE * 5)
local TIMEFORGO = 26 + (TICRATE * 6)

local UPDATESPEED = 2

local endtimer

local flash = {
	[0]	= 655360, //Fully transparent
	[1] = V_90TRANS,
	[2] = V_80TRANS,
	[3] = V_70TRANS,
	[4] = V_60TRANS,
	[5] = V_50TRANS,
	[6] = V_40TRANS,
	[7] = V_30TRANS,
	[8] = V_20TRANS,
	[9] = V_10TRANS,
	[10] = 0 //Fully opaque
}

//Used to set the base start and bonus times for the base maps, and give a default if none is set
rawset(_G, "maptimes", {
	//Base Maps
    [1] =   {75, 30}, //Green Hills Zone 
	[2] =   {100, 45}, 
	[3] =   {90, 45}, 
	[4] =   {75, 30}, 
	[5] =   {80, 35}, 
	[6] =   {80, 35}, 
	[7] =   {85, 40}, 
	[8] =   {75, 30}, 
	[9] =   {90, 45}, 
	[10] =  {100, 60}, 
	[11] =  {75, 30}, 
	[12] =  {80, 35},  
	[13] =  {80, 35}, 
	[14] =  {75, 30}, 
	[15] =  {80, 35}, 
	[16] =  {105, 65}, 
	[17] =  {95, 50}, 
	[18] =  {80, 35}, 
	[19] =  {95, 50}, 
	[20] =  {105, 65}, 
	[21] =  {75, 25}, 
	[22] =  {90, 50}, 
	[23] =  {85, 40}, 
	[24] =  {95, 50}, 
	[25] =  {100, 60}, 
	[26] =  {75, 20}, 
	[27] =  {90, 45}, 
	[28] =  {90, 45}, 
	[29] =  {95, 50}, 
	[30] =  {100, 60},
	[31] =  {90, 45}, 
	[32] =  {95, 50}, 
	[33] =  {85, 40}, 
	[34] =  {80, 35}, 
	[35] =  {100, 55}, 
	[36] =  {75, 30}, 
	[37] =  {80, 35}, 
	[38] =  {95, 50}, 
	[39] =  {90, 45}, 
	[40] =  {100, 60}, 
	[41] =  {70, 15}, 
	[42] =  {75, 25}, 
	[43] =  {100, 60}, 
	[44] =  {70, 20}, 
	[45] =  {95, 55}, 
	[46] =  {70, 20}, 
	[47] =  {70, 15}, 
	[48] =  {75, 30}, 
	[49] =  {70, 25}, 
	[50] =  {80, 35}, 
	[51] =  {70, 15}, 
	[52] =  {70, 15}, 
	[53] =  {65, 10}, 
	[54] =  {80, 25}, 
	[55] =  {70, 15}, 
	
	///Community Maps
	[56] =  {90, 45}, //Lake Margorite Zone
	[57] =  {95, 55}, //Coastal Temple Zone
	[58] =  {80, 35}, //Kart Airlines Zone
	[59] =  {90, 45}, //Honeybee Industry Zone
	[60] =  {80, 35}, //Crimson Core Zone
	
    //MAP HELL Maps
    [352] = {130, 90}, //Crystal Abyss Zone 
    [353] = {75, 30},
    [354] = {70, 25}, 
    [355] = {90, 45}, //VV Classic 
    [356] = {115, 75}, 
    [357] = {90, 45}, 
    [358] = {70, 25}, 
    [359] = {75, 25}, 
    [360] = {85, 40}, //DS Classic 
    [361] = {85, 40}, 
    [362] = {75, 25}, 
    [363] = {80, 30}, 
    [364] = {80, 35},  //FZ Silence 
    [365] = {75, 20}, 
    [369] = {70, 25}, //BM Classic
})

//Ported over from Sneakerless RA
rawset(_G, "taTimes", {
	//Gold Time, Silver Time, Bronze Time (all in Tics)
	// {g*TICRATE, s*TICRATE, b*TICRATE}
	[1]   = {91*TICRATE, 110*TICRATE, 135*TICRATE},
	[2]   = {120*TICRATE, 140*TICRATE, 190*TICRATE},
	[3]   = {121*TICRATE, 135*TICRATE, 180*TICRATE},
	[4]   = {89*TICRATE + 14, 100*TICRATE, 135*TICRATE},
	[5]   = {3416, 130*TICRATE, 150*TICRATE},
	[6]   = {103*TICRATE + 14, 115*TICRATE, 150*TICRATE},
	[7]   = {110*TICRATE + 7, 125*TICRATE, 165*TICRATE},
	[8]   = {85*TICRATE + 7, 100*TICRATE, 135*TICRATE},
	[9]   = {80*TICRATE, 105*TICRATE, 180*TICRATE},
	[10]  = {4081, 140*TICRATE, 160*TICRATE},
	[11]  = {3304, 110*TICRATE, 135*TICRATE},
	[12]  = {97*TICRATE, 110*TICRATE, 140*TICRATE},
	[13]  = {104*TICRATE + 21, 135*TICRATE, 140*TICRATE},
	[14]  = {90*TICRATE, 120*TICRATE, 145*TICRATE},
	[15]  = {92*TICRATE + 21, 110*TICRATE, 160*TICRATE},
	[16]  = {124*TICRATE, 140*TICRATE, 170*TICRATE},
	[17]  = {126*TICRATE, 150*TICRATE, 195*TICRATE},
	[18]  = {3570, 130*TICRATE, 150*TICRATE},
	[19]  = {141*TICRATE, 160*TICRATE, 195*TICRATE},
	[20]  = {117*TICRATE + 14, 145*TICRATE, 170*TICRATE},
	[21]  = {115*TICRATE, 140*TICRATE, 150*TICRATE},
	[22]  = {95*TICRATE, 120*TICRATE, 140*TICRATE},
	[23]  = {120*TICRATE, 135*TICRATE, 165*TICRATE},
	[24]  = {149*TICRATE, 170*TICRATE, 190*TICRATE},
	[25]  = {4151, 135*TICRATE, 160*TICRATE},
	[26]  = {90*TICRATE + 21, 105*TICRATE, 145*TICRATE},
	[27]  = {4690, 160*TICRATE, 180*TICRATE},
	[28]  = {132*TICRATE, 150*TICRATE, 180*TICRATE},
	[29]  = {150*TICRATE, 170*TICRATE, 195*TICRATE},
	[30]  = {118*TICRATE, 135*TICRATE, 160*TICRATE},
	[31]  = {135*TICRATE, 150*TICRATE, 180*TICRATE},
	[32]  = {134*TICRATE + 7, 150*TICRATE, 195*TICRATE},
	[33]  = {112*TICRATE, 130*TICRATE, 165*TICRATE},
	[34]  = {106*TICRATE + 7, 120*TICRATE, 150*TICRATE},
	[35]  = {150*TICRATE, 170*TICRATE, 210*TICRATE},
	[36]  = {3220, 110*TICRATE, 135*TICRATE},
	[37]  = {105*TICRATE, 120*TICRATE, 150*TICRATE},
	[38]  = {128*TICRATE + 21, 165*TICRATE, 195*TICRATE},
	[39]  = {4550, 145*TICRATE, 180*TICRATE},
	[40]  = {3815, 120*TICRATE, 160*TICRATE},
	[41]  = {80*TICRATE, 100*TICRATE, 130*TICRATE},
	[42]  = {3094, 110*TICRATE, 150*TICRATE},
	[43]  = {105*TICRATE, 120*TICRATE, 160*TICRATE},
	[44]  = {83*TICRATE, 110*TICRATE, 130*TICRATE},
	[45]  = {108*TICRATE, 130*TICRATE, 150*TICRATE},
	[46]  = {90*TICRATE, 110*TICRATE, 130*TICRATE},
	[47]  = {90*TICRATE + 28, 110*TICRATE, 130*TICRATE},
	[48]  = {89*TICRATE + 7, 105*TICRATE, 135*TICRATE},
	[49]  = {85*TICRATE,  100*TICRATE, 120*TICRATE},
	[50]  = {60*TICRATE, 80*TICRATE, 150*TICRATE},
	[51]  = {86*TICRATE + 7,  100*TICRATE, 130*TICRATE},
	[52]  = {82*TICRATE + 21,  105*TICRATE, 130*TICRATE},
	[53]  = {82*TICRATE,  90*TICRATE,  105*TICRATE},
	[54]  = {115*TICRATE, 150*TICRATE, 180*TICRATE},
	[55]  = {67*TICRATE+28,  90*TICRATE,  130*TICRATE},
	[56]  = {125*TICRATE+21, 150*TICRATE, 180*TICRATE},
	[57]  = {99*TICRATE, 130*TICRATE, 150*TICRATE},
	[58]  = {102*TICRATE, 120*TICRATE, 150*TICRATE},
	[59]  = {4480, 145*TICRATE, 180*TICRATE},
	[60]  = {105*TICRATE, 130*TICRATE, 150*TICRATE},

	[352] = {147*TICRATE, 160*TICRATE, 220*TICRATE},
	[353] = {96*TICRATE, 105*TICRATE, 135*TICRATE},
	[354] = {73*TICRATE+28, 80*TICRATE, 120*TICRATE},
	[355] = {130*TICRATE+14, 140*TICRATE, 180*TICRATE},
	[356] = {117*TICRATE, 130*TICRATE, 190*TICRATE},
	[357] = {129*TICRATE, 135*TICRATE, 180*TICRATE},
	[358] = {65*TICRATE+21, 80*TICRATE, 125*TICRATE},
	[359] = {79*TICRATE+28, 90*TICRATE, 150*TICRATE},
	[360] = {115*TICRATE, 125*TICRATE, 165*TICRATE},
	[361] = {108*TICRATE+7, 120*TICRATE, 165*TICRATE},
	[362] = {81*TICRATE+14, 87*TICRATE, 150*TICRATE},
	[363] = {117*TICRATE+28, 125*TICRATE, 170*TICRATE},
	[364] = {95*TICRATE, 105*TICRATE, 150*TICRATE},
	[365] = {78*TICRATE, 90*TICRATE, 155*TICRATE},
	[369] = {84*TICRATE, 95*TICRATE, 120*TICRATE}
})

local backupTimes = maptimes
local backupTATimes = taTimes

rawset(_G, "setmaps", {})

for i = 1, 60 do
	setmaps[i] = true
end
for i = 352, 365 do
	setmaps[i] = true
end
setmaps[369] = true

rawset(_G, "setnewmaptime", function(p, map, base, bonus, override)
	local newbase = tonumber(base)
	local newbonus = tonumber(bonus)
	if not (tonumber(map) and newbase) then
		CONS_Printf(p,"Missing map number and/or base time!")
		return
	end
	if not mapheaderinfo[tonumber(map)] then
		CONS_Printf(p,"Map "..map.." doesn't currently exist!")
	end
	if (not newbonus) and (not mapheaderinfo[map].arcadeboss) then
		CONS_Printf(p,"Missing time bonus!")
		return
	end
	newbase = max(30,$)
	if newbase%5 > 0 then
		newbase = $ + 5 - ($%5)
	end
	if mapheaderinfo[map].arcadeboss then
		newbonus = 0
	else
		newbase = min(180,$)
		newbonus =  min(90,max(10,$))
	end
	if newbonus%5 > 0 then
		newbonus = $ + 5 - ($%5)
	end
	local bronzetime = (newbase + ((mapheaderinfo[map].numlaps - 1) * newbonus))*TICRATE
	local silvertime = bronzetime - (TICRATE*5*mapheaderinfo[map].numlaps)
	local goldtime = bronzetime - (TICRATE*10*mapheaderinfo[map].numlaps)
	if setmaps[tonumber(map)] and not override then
		CONS_Printf(p,"This map already has a time limit set!")
		return
	else
		if override and setmaps[tonumber(map)] then CONS_Printf(p,"Overriding times for Map "..map.."...") end
		maptimes[tonumber(map)] = {newbase, newbonus}
		taTimes[map] = {goldtime, silvertime, bronzetime}
		setmaps[tonumber(map)] = true
		CONS_Printf(p,"Map times for Map "..map.."are set! "..maptimes[tonumber(map)][1].."s start, "..maptimes[tonumber(map)][2].."s bonus per lap")
	end
end)

COM_AddCommand("setmaptime", function(p, map, base, bonus, override)
	setnewmaptime(p, map, base, bonus, override)
end, 1)

COM_AddCommand("checkmaptime", function(p, map)
	if not tonumber(map) then
		CONS_Printf(p, "Missing map number!")
	elseif setmaps[tonumber(map)] then
		CONS_Printf(p, maptimes[tonumber(map)][1].."s start, "..maptimes[tonumber(map)][2].."s bonus for map "..map)
	else
		CONS_Printf(p, "This map doesn't have a time set yet!")
	end
end)

//You can use this to automatically input the times in should this mod be loaded in first:
//if rawget(_G, "maptimes") then setnewmaptime(map, base, bonus, override) end

local timeextension = {
{sfx_amtex1, 50},
{sfx_amtex2, 60},
{sfx_amtex3, 90},
{sfx_amtex4, 90},
{sfx_amtex5, 85}
}

local lapstogosfx = {
	[1] = sfx_am1lpr,
	[2] = sfx_am2lpr,
	[3] = nil,
	[5] = sfx_am5lpr,
	[7] = sfx_am7lpr,
	[10] = nil,
	[12] = nil,
	[15] = nil,
	[20] = nil,
	[25] = nil,
	[30] = nil,
	[40] = nil,
	[49] = nil
}

local legstogosfx = {
	[1] = sfx_am1lgr,
	[2] = sfx_am2lgr,
	[3] = nil
}

local ITEMCHANGE = {
	-1, //Sneaker
	-1, //Rocket Sneaker
	-1, //Invincability
	1, //Banana
	1, //Buttnic Monitor
	1, //Orbinaut
	1, //Jawz
	1, //Mine
	1, //Ballhog
	2, //Blue Bomb
	2, //Grow
	3, //Shrink
	-1, //Thunder Shield
	-1, //Hyudoro
	-1, //Pogo Spring
	-1 //Kitchen Sink
}

local ITEMCHANGELRMAX = {
	-1, //Sneaker
	-1, //Rocket Sneaker
	-1, //Invincability
	-1, //Banana
	-1, //Buttnic Monitor
	-1, //Orbinaut
	-1, //Jawz
	-1, //Mine
	-1, //Ballhog
	3, //Blue Bomb
	3, //Grow
	3, //Shrink
	-1, //Thunder Shield
	-1, //Hyudoro
	-1, //Pogo Spring
	-1 //Kitchen Sink
}

//The base Max Speed for all 9 base speed types 
local basemaxspeed = setmetatable({
	2519263, //Speed 1
	2568660, //Speed 2
	2618057, //Speed 3
	2667455, //Speed 4
	2716852, //Speed 5
	2766249, //Speed 6
	2815647, //Speed 7
	2865044, //Speed 8
	2914441  //Speed 9
}, {__index = function() return 2716852 end})

//The Max RPM (outside of boosting) for all 9 base weight types. Can be adjusted
local baseRPM = setmetatable({
	7000, //Weight 1
	7125, //Weight 2
	7250, //Weight 3
	7375, //Weight 4
	7500, //Weight 5
	7625, //Weight 6
	7750, //Weight 7
	7875, //Weight 8
	8000, //Weight 9 (Weight 1 in SPBAttack)
	8250, //Weight 2 in SPBAttack
	8500, //Weight 3 in SPBAttack
	8750, //Weight 4 in SPBAttack
	9000, //Weight 5 in SPBAttack
	9250, //Weight 6 in SPBAttack
	9500, //Weight 7 in SPBAttack
	9750, //Weight 8 in SPBAttack
	10000 //Weight 9 in SPBAttack
}, {__index = function() return 7500 end})


local function settimelimit(map)
	local timelimit
	local basetimelimit
	local lapmod
	local estimatedlaptime
	local bonus
	
	local mapset = maptimes[map]
	basetimelimit = mapset[1]
	
	if mapheaderinfo[map].arcadeboss then //Overrides for Boss Maps with fixed time limits
		return basetimelimit * TICRATE
	end
	
	if daytonakart.diff == 69 then
		timelimit = basetimelimit + daytonakart.startmod
	//Modify the Time Limit depending on the Difficulty
	elseif daytonakart.diff > 0 then //Easy Mode gives a mod to the timelimit. You get at least 5s more on Easy, and 10s more on Easiest.
		timelimit = (basetimelimit * (100 + daytonakart.diff)) / 50
		if (timelimit % 10) > 4 then //Round it to a multiple of 5s
			timelimit = $ + 10 - (timelimit % 10)
		else
			timelimit = $ - (timelimit % 10)
		end 
		timelimit = $ / 2
		if basetimelimit == timelimit then timelimit = basetimelimit + 5 end
		if (basetimelimit + 5) == timelimit and daytonakart.diff == 30 then timelimit = basetimelimit + 10 end
	elseif daytonakart.diff < 0 then //Hard, Expert and Master gives a starting time penalty
		timelimit = basetimelimit + daytonakart.diff //As difficulty.value is negative, this reduces the time limit
		if basetimelimit < 15 then basetimelimit = 15 end //But never lower than 15s
	else
		timelimit = basetimelimit
	end
	//print("Starting Time: "..timelimit.."s")
	
	lapmod = numlaps
	lapmod = $ - mapheaderinfo[map].numlaps //Postive if numlaps is more than mapheaderinfo[map].numlaps
	//print("Number of Laps: "..numlaps)
	//print("Original Laps: "..mapheaderinfo[map].numlaps)
	//print("lapmod: "..lapmod)
	
	local errorbonus = daytonakart.extimemod * lapmod
	if lapmod ~= 0 and errorbonus == 0 then
		errorbonus = 5 * lapmod
	elseif (errorbonus % 5) > 2 then
		errorbonus = $ - ($ % 5) + 5
	elseif (errorbonus % 5) > 0 then
		errorbonus = $ - ($ % 5)
	end
	
	timelimit = $ + errorbonus
		
	return timelimit * TICRATE
end

local function bonustime(map)
	local bonus
	
	local mapset = maptimes[map]
	bonus = mapset[2]
	
	if mapheaderinfo[map].arcadeboss then return 0 end //No Bonus time in Boss Maps!
	
	if daytonakart.diff == 69 then
		bonus = $ + daytonakart.lapmod
		if bonus < 5 then bonus = 5 end
	//Modify the Bonus depending on the Difficulty
	elseif daytonakart.diff > 0 then //Easy/Easiest Mode gives a mod to the bonus time
		bonus = ($ * (100 + daytonakart.diff)) / 50
		if (bonus % 2) == 1 then bonus = $ + 1 end
		bonus = $ / 2
	elseif daytonakart.diff < 0 then //Hard and Expert reduces the bonus
		bonus = $ + (daytonakart.diff / 2) //Hard reduces it by 2s, Expert by 5s
		if bonus < 5 then bonus = 5 end //But to no fewer than 5 seconds
	end
	
	return bonus * TICRATE
end

local function firstloadmap(map, force)
	if setmaps[map] and (not force) then return false end //This map has been loaded in before.
	local basetime = tonumber(mapheaderinfo[map].arcadetime)
	if basetime == nil then
		basetime = BASETIME
	elseif basetime < 30 then
		basetime = 30
	elseif (basetime > 180) and (not mapheaderinfo[map].arcadeboss) then 
		basetime = 180
	elseif (basetime%5) ~= 0 then
		basetime = $ + 5 - ($%5)
	end
	local bonustime = tonumber(mapheaderinfo[map].arcadebonus)
	if bonustime == nil then
		bonustime = BASEBONUS
	elseif mapheaderinfo[map].arcadeboss then
		bonustime = 0
	elseif bonustime < 10 then
		bonustime = 10
	elseif bonustime > 90 then
		bonustime = 90
	elseif (bonustime%5) ~= 0 then
		bonustime = $ + 5 - ($%5)
	end
	if bonustime > basetime then bonustime = basetime end
	local bronzetime = (basetime + ((mapheaderinfo[map].numlaps - 1) * bonustime))*TICRATE
	local silvertime = bronzetime - (TICRATE*5*mapheaderinfo[map].numlaps)
	if mapheaderinfo[map].arcadesilver then silvertime = min(tonumber(mapheaderinfo[map].arcadesilver)*TICRATE, bronzetime - (5*TICRATE)) end
	local goldtime = min(bronzetime - (TICRATE*10*mapheaderinfo[map].numlaps), silvertime - TICRATE)
	if mapheaderinfo[map].arcadegold then goldtime = min(tonumber(mapheaderinfo[map].arcadegold), silvertime - TICRATE) end
	maptimes[map] = {basetime, bonustime}
	taTimes[map] = {goldtime, silvertime, bronzetime}
	setmaps[map] = true
	if not force then print("Map "..map.." is now loaded!") end
	return true //This is the first time loading in the map!
end

COM_AddCommand("resetmaptime", function(p, map)
	if not map then 
		return
	end
	map = tonumber(map)
	if setmaps[map]  then
		if backupTimes[map] then
			maptimes[map] = backupTimes[map]
			taTimes[map] = backupTATimes[map]
			CONS_Printf(p, "Map reset to the internal backup!")
		else
			firstloadmap(map, true)
			CONS_Printf(p, "Map reset to the SOC data!")
		end
	else
		CONS_Printf(p, "This map doesn't have a time set yet!")
	end
end)

local function startset(player, map)
	//Input: The player, and the Map Number
	//Doesn't return anything, but sets the player.arcade values
	if player.arcade == nil then player.arcade = {} end
	if not (gametype & GT_MATCH) then
		if not setmaps[map] then firstloadmap(map) end
		player.arcade.timelimit = settimelimit(map) //Default time limit
		if player.realtime > 0 then player.realtime = 0 end //Reset the timer to the start.
		player.arcade.extendflash = 0 //Used to flash the Time Extension image and also for the TIMEOVER screen
		player.arcade.lapcheck = 0 //Used to check if the lap had changed
		player.arcade.timeover = false //Used to show if time had run out
		player.arcade.mo = nil //Used for the death mobj
		player.arcade.bonustime = bonustime(map)
		player.arcade.quirplength = 0 //Used to delay lap notifications
		player.arcade.numlaps = 0 //Used for if there are multiple 'laps' per lap
		if player.realtime > player.arcade.timelimit then player.realtime = 0 end //Gives new players a .realtime of 0 if time had otherwise expired
		player.arcade.timetoshow = player.arcade.timelimit / TICRATE 
		player.arcade.wariotime = player.arcade.timelimit / TICRATE //Wario Time works slightly different to normal time
		player.arcade.timeincrease = 0 // Used to extend the time limit a la Initial D
		player.arcade.teamtimebonus = false //Did a teammate extend the time for us?
		player.arcade.hpcapped = false //Has HP been capped yet?
		if mapheaderinfo[map].noextension then
			player.arcade.timelimit = $ + ((numlaps - 1) * player.arcade.bonustime)
			player.arcade.timetoshow = player.arcade.timelimit / TICRATE 
			player.arcade.wariotime = player.arcade.timelimit / TICRATE
		end
		player.arcade.autoreset = false
	else
		local timelimit
		if server.deli_timelimit then 
			timelimit = server.deli_timelimit
		else
			timelimit = CV_FindVar("timelimit").value
		end
		if timelimit then
			player.arcade.timelimit = timelimit * 60 * TICRATE
		else
			player.arcade.timelimit = 0
		end
		player.arcade.bumplag = 0
		player.arcade.lastbumphealth = 0
		player.arcade.extendflash = 0
	end
	if hpmod and hpmod.running then
		player.arcade.hpcap = hpmod.maxhp
	end
end

local function hpbarcheck()
	if not (hpmod and hpmod.running) then return end
	if splitscreen then
		hpmod_showbar = true
	elseif (arcadehpbar.value == 1) and (hpmod_showbar == true) then
		hpmod_showbar = false
	elseif (arcadehpbar.value == 0) and (hpmod_showbar == false) then 
		hpmod_showbar = true
	end
end

local function DK_ReturnSplitFlags(f, displaynum)
	if not (splitscreen) return f end

	-- exhibit 1: 2p
	if (splitscreen == 1)
		if not (displaynum) -- p1
			return f & ~(V_SNAPTOBOTTOM)
		else	-- p2
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP)
		end
	else
		-- jesus fuck this sucks dicks
		if not (displaynum)	-- p1
			return f & ~(V_SNAPTOBOTTOM|V_SNAPTORIGHT)
		elseif (displaynum == 1)	-- p2
			return (f|V_HORZSCREEN) & ~(V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif (displaynum == 2)	-- p3
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP|V_SNAPTORIGHT)
		elseif (displaynum == 3)	-- p4
			return (f|V_SPLITSCREEN|V_HORZSCREEN) & ~(V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
	
	return f	-- shouldn't happen but don't return nil either way lol
end

local function drawLetter(v, font, char, x, y, f, c)
	local asc = string.byte(char)
	local padding = "000"
	if asc > 99
		padding = ""
	elseif asc > 9
		padding = "0"
	elseif asc > 0
		padding = "00"
	end
	v.draw(x, y, v.cachePatch(font .. padding .. tostring(asc)), f, c)
end

local function drawLetterScaled(v, font, char, x, y, scale, f, c)
	local asc = string.byte(char)
	local padding = "000"
	if asc > 99
		padding = ""
	elseif asc > 9
		padding = "0"
	elseif asc > 0
		padding = "00"
	end
	v.drawScaled(x, y, scale, v.cachePatch(font .. padding .. tostring(asc)), f, c)
end

local function drawManiaNum(v, num, x, y, f, colflag)
	local font = "R_NUM_"
	if colflag == REDTEXT then font = "R"..$
	elseif colflag == GREENTEXT then font = "G"..$ end
	v.draw(x, y, v.cachePatch(font .. num), f)
end

local function drawManiaTime(v, time, x, y, f, colflag)
	local str = tostring(time)
	local leftx = x - (string.len(str) * 7)
	for a=1,string.len(str) do
		drawManiaNum(v, string.sub(str, a, a), leftx + ((a - 1) * 14), y, f, colflag)
	end
end

local FONTSTRINGOFFSET =  setmetatable({
	["LRMXG"] = -2,
	["LRMXY"] = -2,
	["LRMXR"] = -2,
}, {__index = function() return 0 end})

local function drawFontString(v, font, str, x, y, spacing, f, c)
	for a=1,string.len(str) do
		drawLetter(v, font, string.sub(str, a, a), x + ((a - 1) * spacing), y, f, c)
	end
end

local function getLetterAsciiCode(char)
	local asc = string.byte(char)
	local padding = "000"
	if asc > 99
		padding = ""
	elseif asc > 9
		padding = "0"
	elseif asc > 0
		padding = "00"
	end
	return padding .. asc
end

local function drawNewString(v, font, str, x, y, f, c, style)
	if str == nil
	or string.len(str) == 0
		str = "NIL"
	end
	local strPatches = {}
	local strLenPix = 0
	for a=1,string.len(str) do
		local letter = string.sub(str, a, a)
		if letter != " " then
			strPatches[a] = v.cachePatch(font .. getLetterAsciiCode(letter))
			strLenPix = $ + strPatches[a].width
			if FONTSTRINGOFFSET[font] then strLenPix = $ + FONTSTRINGOFFSET[font] end
		else
			strLenPix = $ + 6
		end
	end
	local lx = x
	if style == "right" then
		lx = x - (strLenPix - FONTSTRINGOFFSET[font])
	elseif style == "center" then
		lx = x - ((strLenPix - FONTSTRINGOFFSET[font]) / 2)
	end
	for a=1,string.len(str) do
		if strPatches[a] then
			v.draw(lx, y, strPatches[a], f, c)
			lx = $ + strPatches[a].width
			if FONTSTRINGOFFSET[font] then lx = $ + FONTSTRINGOFFSET[font] end
		else
			lx = $ + 6
		end
	end
end

local function drawLRMAXNum(v, time, x, y, f, colflag, tics, pos)
	local str
	local font = "LRMXG"
	if colflag == REDTEXT then font = "LRMXR"
	elseif colflag == YELLOWTEXT then font = "LRMXY" end
	if tics then
		local secs = time / 35
		if secs < 10 then
			local ds = G_TicsToCentiseconds(time) / 10
			str = tostring(secs) .. "." .. tostring(ds)
		else
			str = tostring(secs)
		end
	else
		str = tostring(time)
	end
	drawNewString(v, font, str, x, y, f, nil, pos)
end

local function drawScaledFontString(v, font, str, x, y, spacing, scale, f, c)
	for a=1,string.len(str) do
		drawLetterScaled(v, font, string.sub(str, a, a), x + ((a - 1) * spacing), y, scale, f, c)
	end
end

local function drawNewStringScaled(v, font, str, x, y, scale, f, c, style)
	if str == nil
	or string.len(str) == 0
		str = "NIL"
	end
	local strPatches = {}
	local strLenPix = 0
	for a=1,string.len(str) do
		local letter = string.sub(str, a, a)
		if letter != " " then
			strPatches[a] = v.cachePatch(font .. getLetterAsciiCode(letter))
			strLenPix = $ + (strPatches[a].width * scale)
			if FONTSTRINGOFFSET[font] then strLenPix = $ + (FONTSTRINGOFFSET[font] * scale) end
		else
			strLenPix = $ + (6 * scale)
		end
	end
	local lx = x
	if style == "right" then
		lx = x - (strLenPix - (FONTSTRINGOFFSET[font] * scale))
	elseif style == "center" then
		lx = x - ((strLenPix - (FONTSTRINGOFFSET[font] * scale)) / 2)
	end
	for a=1,string.len(str) do
		if strPatches[a] then
			v.drawScaled(lx, y, scale, strPatches[a], f, c)
			lx = $ + (strPatches[a].width * scale)
			if FONTSTRINGOFFSET[font] then strLenPix = $ + (FONTSTRINGOFFSET[font] * scale) end
		else
			lx = $ + (6 * scale)
		end
	end
end

local function drawMKtext(v, str, x, y, flags)
	if str == nil
	or string.len(str) == 0
		str = "NIL"
	end
	str = tostring(str)
	str = str:upper()
	drawFontString(v, "MKFNT", str, x, y, 12, flags)
end

local function drawSmallWarioLandNumber(v, num, x, y, flags)
	if num == nil
	or string.len(num) == 0
		num = "0"
	end
	num = tostring(num)
	drawScaledFontString(v, "WTMR", num, x*FRACUNIT, y*FRACUNIT, 9*FRACUNIT, FRACUNIT/2, flags) 
end


local function padTimerZero(num)
	if num < 10
		return "0" .. tostring(num)
	else
		return tostring(num)
	end
end

local function drawTimer(v, str, xmid, y, flags, color)
	if str == nil
	or string.len(str) == 0
		str = "0"
	end
	str = tostring(str)
	str = str:upper()
	if string.len(str) == 1 then str = "0" .. $ end
	local x = xmid
	x = $ - (string.len(str) * 9)
	local font = "TMER"
	if color == REDTEXT then font = $ .. "R"
	elseif color == GREENTEXT then font = $ .. "G"
	elseif color == YELLOWTEXT or (daytonakart.firstblood.enabled and not daytonakart.firstblood.blooddrawn) then 
		font = $ .. "Y"
	end
	drawFontString(v, font, str, x, y, 18, flags)
end

local function drawSplitTimer(v, str, xmid, y, flags, color)
	if str == nil
	or string.len(str) == 0
		str = "0"
	end
	str = tostring(str)
	str = str:upper()
	if string.len(str) == 1 then str = "0" .. $ end
	local x = xmid*FRACUNIT
	local ypos = y*FRACUNIT
	x = $ - ((string.len(str) * 9) * (FRACUNIT/2))
	local font = "TMER"
	if color == REDTEXT then font = $ .. "R" end
	if color == GREENTEXT then font = $ .. "G" end
	if color == YELLOWTEXT then font = $ .. "Y" end
	v.drawString(xmid, y-8, "TIME", flags, "center")
	drawScaledFontString(v, font, str, x, ypos, 9*FRACUNIT, FRACUNIT/2, flags)
end

local function drawTAMedalTimes(v, p, x, y, flags)
	if not (p and p.valid) then return end
	if not taTimes[gamemap] then return end
	local timestep = false
	for i = 0, 2 do
		if taTimes[gamemap][i+1] then
			local medalpatch = ({
				[0] = v.cachePatch("GOTITA"),
				[1] = v.cachePatch("GOTITB"),
				[2] = v.cachePatch("GOTITF")
			}) [i]
			local time = taTimes[gamemap][i+1]
			local str = padTimerZero(G_TicsToMinutes(time, true)) .. ":" .. padTimerZero(G_TicsToSeconds(time)) .. "." ..  padTimerZero(G_TicsToCentiseconds(time))
			local colflag = 0
			if (not timestep) and (time > p.realtime) then 
				if p.exiting then colflag = V_GREENMAP else colflag = V_YELLOWMAP end
				timestep = true
			end
			v.drawScaled(x*FRACUNIT, (y + (10*i))*FRACUNIT, FRACUNIT/2, medalpatch, flags)
			if p.realtime >= time then 
				local fflags = flags&(~V_HUDTRANS)
				fflags = $|V_HUDTRANSHALF
				colflag = V_GRAYMAP
				v.drawScaled(x*FRACUNIT, (y + (10*i))*FRACUNIT, FRACUNIT/2, v.cachePatch("NEEDIT"), fflags)
			end
			v.drawString(x+10, y + (10*i), str, flags|colflag)
		end
	end
end

local function secsToTimer(num, flash, leadingzero)
	local mins
	local colon
	local secs
	if leadingzero then
		if num >= 60 then
			mins = padTimerZero(num / 60)
		else
			mins = "00"
		end
	else
		if num >= 60 then
			mins = num / 60
		else
			mins = "0"
		end
	end
	if flash then colon = ":" else colon = " " end
	secs = padTimerZero(num % 60)
	return mins .. colon .. secs
end

local function drawWarioLandTimer(v, p, timer, xmid, y, flags, forcewhite)
	if not (p and p.valid) then return end
	local timercolon = (((p.realtime % TICRATE) < (TICRATE / 2) or p.exiting) and true or false) 
	local timerstring = secsToTimer(timer, timercolon)
	local fontstring = "WTMR"
	
	if server.SPBArunning and leveltime >= TIMEFORGO then
		if (p.realtime % TICRATE/2) < (TICRATE / 4) then fontstring = "WTMRR" else fontstring = "WTMRR" end
	elseif not forcewhite then
		if timer <= 10 then
			fontstring = "WTMRR"
		elseif timer <= 30 or (daytonakart.firstblood.enabled and not daytonakart.firstblood.blooddrawn) then
			fontstring = "WTMRY"
		end
	end
	
	local x = xmid
	x = $ - (4 * 9)
	drawFontString(v, fontstring, timerstring, x, y, 18, flags)
	
	local clockpatch
	local clockframe = (p.realtime % 18) / 3
	
	clockpatch = "WTMRCK" .. tostring(clockframe)
	v.draw(x, y, v.cachePatch(clockpatch), flags)
end

local function drawWarioLandSplitTimer(v, p, timer, xmid, y, flags)
	if not (p and p.valid) then return end
	local timercolon = (((p.realtime % TICRATE) < (TICRATE / 2) or p.exiting) and true or false) 
	local timerstring = secsToTimer(timer, timercolon)
	local fontstring = "WTMR"
	
	if timer <= 10 then
		fontstring = "WTMRR"
	elseif timer <= 30 or (daytonakart.firstblood.enabled and not daytonakart.firstblood.blooddrawn) then
		fontstring = "WTMRY"
	end
	
	local x = (xmid - 18)
	drawScaledFontString(v, fontstring, timerstring, x*FRACUNIT, y*FRACUNIT, 9*FRACUNIT, FRACUNIT/2, flags)
	
	local clockpatch
	local clockframe = (p.realtime % 18) / 3
	
	clockpatch = "WTMRCK" .. tostring(clockframe)
	v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT/2, v.cachePatch(clockpatch), flags)
end

local function drawLRMAXTimer(v, x, y, time, flags)
	drawNewString(v, "LRMT", "TIME", x, y, flags, nil, "center")
	drawNewString(v, "LRMT", "LIMIT", x, y+7, flags, nil, "center")
	local colflag = GREENTEXT
	if time <= 30*TICRATE then
		if time < 10*TICRATE then
			if (time % 10) <= 4 then colflag = REDTEXT end
		else
			if (time % TICRATE) <= (TICRATE / 2) then colflag = YELLOWTEXT end
		end
	end
	drawLRMAXNum(v, time, x, y+15, flags, colflag, true, "center")
end

local function timeextended(p)
	local rand = P_RandomRange(1, #timeextension)
	local quirp = timeextension[rand]
	S_StartSound(nil,quirp[1],p)
	return quirp[2]
end

local function drawLRMAXLaps(v, p, n, map, flags, flash)
	if not (p and p.valid) then return end
	if (gametype & GT_MATCH) then return end
	local currentlap
	local lapstring = "LAP"
	local sectorstring
	local maxlaps
	local maxsectors
	local col = GREENTEXT
	if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE then
		lapstring = "LEG"
		currentlap = p.laps + 1
		if p.laps == numlaps then currentlap = p.laps end
		if (p.laps + 1) >= numlaps then col = YELLOWTEXT end
		maxlaps = numlaps 
	elseif tonumber(mapheaderinfo[map].lapcheckpoints) ~= nil then
		currentlap = p.arcade.numlaps + 1
		if (p.laps + tonumber(mapheaderinfo[map].lapcheckpoints)) >= numlaps then col = YELLOWTEXT end
		maxlaps = numlaps / tonumber(mapheaderinfo[map].lapcheckpoints)
		maxsectors = tonumber(mapheaderinfo[map].lapcheckpoints)
		sectorstring = "Sector " .. (p.laps % tonumber(mapheaderinfo[map].lapcheckpoints) + 1) .. " of " .. maxsectors
		if p.laps == numlaps then 
			currentlap = maxlaps
			sectorstring = "Sector " .. maxsectors .. " of " .. maxsectors
		end
	else
		currentlap = p.laps + 1
		if p.laps == numlaps then currentlap = p.laps end
		if (p.laps + 1) >= numlaps then col = YELLOWTEXT end
		maxlaps = numlaps 
	end
	if flash then 
		if col ~= YELLOWTEXT then col = YELLOWTEXT else col = GREENTEXT end
	end
	local y = 8
	if SPLITS and Splits_Runtype() then y = $ + 10 end
	local x = 312
	drawNewString(v, "LRMT", lapstring, 272, 19, flags, nil, "right")
	drawLRMAXNum(v, padTimerZero(currentlap), x, y, flags, col, false, "right")
	drawNewString(v, "LRMT", "OF "..padTimerZero(maxlaps), x, 29, flags, nil, "right")
	if tonumber(mapheaderinfo[map].lapcheckpoints) ~= nil then
		v.drawString(316, 37, sectorstring, flags, "small-right")
	end
end

local function drawlaps(v, p, n, map, flags, flash)
	if not (p and p.valid) then return end
	if (gametype & GT_MATCH) then return end
	if (not splitscreen) and (abs(daytonakart.hud) == LRMAXHUD) then
		drawLRMAXLaps(v, p, n, map, flags, flash)
		return
	end
	local currentlap
	local lapstring = "LAP"
	local sectorstring
	local maxlaps
	local maxsectors
	local font = "TMER"
	if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE then
		lapstring = "LEG"
		currentlap = p.laps + 1
		if p.laps == numlaps then currentlap = p.laps end
		if (p.laps + 1) >= numlaps then font = "TMERY" end
		maxlaps = numlaps 
	elseif tonumber(mapheaderinfo[map].lapcheckpoints) ~= nil then
		currentlap = p.arcade.numlaps + 1
		if (p.laps + tonumber(mapheaderinfo[map].lapcheckpoints)) >= numlaps then font = "TMERY" end
		maxlaps = numlaps / tonumber(mapheaderinfo[map].lapcheckpoints)
		maxsectors = tonumber(mapheaderinfo[map].lapcheckpoints)
		sectorstring = "Sector " .. (p.laps % tonumber(mapheaderinfo[map].lapcheckpoints) + 1) .. " of " .. maxsectors
		if p.laps == numlaps then 
			currentlap = maxlaps
			sectorstring = "Sector " .. maxsectors .. " of " .. maxsectors
		end
	else
		currentlap = p.laps + 1
		if p.laps == numlaps then currentlap = p.laps end
		if (p.laps + 1) >= numlaps then font = "TMERY" end
		maxlaps = numlaps 
	end
	
	if flash then font = "TMERG" end
	if splitscreen then
		local px
		local py
		if splitscreen == 1 then
			px = 300
			if maxlaps > 9 then px = 290 end
			if n == 1 then 
				py = 10
			else
				py = 80
			end
		else
			if n%2 == 1 then
				px = 20 
			else 
				px = 140
				if maxlaps > 9 then px = $ - 10 end
			end
			py = 80
		end
		v.drawString(px, py+2, lapstring, flags, "small-right")
		v.drawString(px, py+14, "OF "..numlaps, flags, "small")
		if maxlaps > 9 and currentlap <= 9 then currentlap = "0" .. $ end
		drawScaledFontString(v, font, tostring(currentlap), px*FRACUNIT, py*FRACUNIT, 9*FRACUNIT, FRACUNIT/2, flags)
		if splitscreen > 1 then
			local positiontext = "TH"
			local posflags = 0
			if (p.laps + 1) >= numlaps then
				if server.SPBAwin then
					posflags = V_YELLOWMAP
				elseif K_IsPlayerLosing(p) or (p.pflags & PF_TIMEOVER) then
					posflags = V_REDMAP
				elseif p.kartstuff[k_position] == 1 then
					posflags = V_YELLOWMAP
				end
			elseif p.pflags & PF_TIMEOVER then
				posflags = V_REDMAP
			end
			if flash then posflags = V_GREENMAP end
			if p.kartstuff[k_position] == 1 then positiontext = "ST" end
			if p.kartstuff[k_position] == 2 then positiontext = "ND" end
			if p.kartstuff[k_position] == 3 then positiontext = "RD" end
			v.drawString(px + ((maxlaps > 9) and 10 or 0), py-4, p.kartstuff[k_position]..positiontext, flags|posflags, "small")
		end
	else
		local y = 4
		if SPLITS and Splits_Runtype() then y = $ + 10 end
		if (daytonakart.hud == 2) or (daytonakart.hud == 4) then
			font = "WTMR"
			if maxlaps > 9 then
				if currentlap <= 9 then currentlap = "0" .. $ end
				v.drawString(278, y, lapstring, flags, "right")
				drawFontString(v, font, tostring(currentlap), 280, y, 18, flags)
			else
				v.drawString(296, y, lapstring, flags, "right")
				drawFontString(v, font, tostring(currentlap), 298, y, 18, flags)
			end
			v.drawString(316, y + 32, "OF "..tostring(maxlaps), flags, "right")
			if tonumber(mapheaderinfo[map].lapcheckpoints) ~= nil then
				v.drawString(316, y + 44, sectorstring, flags, "small-right")
			end
		else
			v.drawString(289, y, lapstring, flags, "right")
			if maxlaps > 9 then
				if currentlap <= 9 then currentlap = "0" .. $ end
				drawFontString(v, font, tostring(currentlap), 226, y + 10, 18, flags)
				v.drawString(280, y + 20, "OF", flags, "right")
				drawFontString(v, font, tostring(maxlaps), 280, y + 10, 18, flags)
			else
				drawFontString(v, font, tostring(currentlap), 262, y + 10, 18, flags)
				v.drawString(298, y + 20, "OF", flags, "right")
				drawFontString(v, font, tostring(maxlaps), 298, y + 10, 18, flags)
			end
			if tonumber(mapheaderinfo[map].lapcheckpoints) ~= nil then
				v.drawString(316, y + 38, sectorstring, flags, "small-right")
			end
		end
	end
end

local function convertspeed(speed, speedtype, mobjscale)
	local convertedspeed
	local fractionspeed
	local typetext
	local result
	if speedtype == MILESPERHOUR then
		typetext = "MPH"
		convertedspeed = FixedDiv(FixedMul(speed, 88465), mobjscale)/(FRACUNIT/10)
	elseif speedtype == KILOMETERSPERHOUR then
		typetext = "KM/H"
		convertedspeed = FixedDiv(FixedMul(speed, 142371), mobjscale)/(FRACUNIT/10)
	elseif speedtype == METERSPERSECOND then
		typetext = "M/S"
		convertedspeed = FixedDiv(FixedMul(speed, 39547), mobjscale)/(FRACUNIT/10)
	elseif speedtype == FRACUNITSPERTIC then
		typetext = "FU/T"
		convertedspeed = FixedDiv(speed, mobjscale)/(FRACUNIT/10)
	elseif speedtype == NAUTICALMILESPERHOUR then
		typetext = "KNOT"
		convertedspeed = FixedDiv(FixedMul(speed, 76874), mobjscale)/(FRACUNIT/10)
	elseif speedtype == FOOTPERSECOND then
		typetext = "FT/S"
		convertedspeed = FixedDiv(FixedMul(speed, 129747), mobjscale)/(FRACUNIT/10)
	end
	fractionspeed = convertedspeed % 10
	convertedspeed = $ / 10
	return convertedspeed, fractionspeed, typetext
end

local RPMTIC = 125

local function boostchargerpm(charge, perfectRPM, overRPM)
	//Returns 1000 if charge == 0, approx perfectRPM if charge is 35 or 36,
	//slightly over if 37-40, and at least overRPM if 50 or more
	
	local MINRPM = 1000
	local phaseOne = (perfectRPM - MINRPM)/35
	local phaseTwo = perfectRPM/80
	local phaseThree = (overRPM - (perfectRPM + (perfectRPM/20)))/10
	local phaseMax = overRPM/200
	
	local result = MINRPM
	if charge <=35 then
		result = $ + phaseOne*charge
		return result
	end
	result = perfectRPM
	if charge == 36 then return result end
	if charge <= 40 then
		result = $ + phaseTwo*(charge-36)
	elseif charge <= 49 then
		result = $ + phaseTwo*4 + phaseThree*(charge-40)
	else
		result = overRPM + phaseMax*(charge-50)
	end
	return result
end

//This is used to make the custom speedometer
local function drawspeed(v, p, x, y, flags)
	if not (p and p.valid) then return end
	if p.speed == nil or p.kartweight == nil or p.kartspeed == nil then return end
	local rpm = 1000 + FixedDiv(FixedMul(FixedDiv(p.speed, mapheaderinfo[gamemap].mobj_scale), (baseRPM[p.kartweight] - 1000)), basemaxspeed[p.kartspeed])
	//Do custom RPM checks for during the start of a race here
	if leveltime <= TIMEFORGO then
		rpm = boostchargerpm(p.kartstuff[k_boostcharge], 8000, 10000)
	end
	//x = 18
	//y = 150
	
	local rpmtics = (rpm/RPMTIC) + 1
	local wholespeed
	local tenthspeed
	local typetext
	local speedtext
	wholespeed, tenthspeed, typetext = convertspeed(p.speed, customspeedometer.value, mapheaderinfo[gamemap].mobj_scale)
	
	//Draw base image
	v.draw(x, y, v.cachePatch("HUDSPEED"), flags)
	
	if rpmtics > 7 then
		if rpmtics < 32 then
			v.drawFill(x+10, y+10, (rpmtics - 8), 5, 187)
			local transparency = (rpm%RPMTIC)/(RPMTIC/10)
			v.draw(x + 2 + rpmtics, y+10, v.cachePatch("HUDSPD1"), flash[transparency])
		else
			v.drawFill(x+10, y+10, 24, 5, 187)
			if rpmtics < 64 then
				v.drawFill(x+34, y+10, (rpmtics - 32), 7, 106)
				local transparency = (rpm%RPMTIC)/(RPMTIC/10)
				v.draw(x + 2 + rpmtics, y+10, v.cachePatch("HUDSPD2"), flash[transparency])
			else
				v.drawFill(x+34, y+10, 32, 7, 106)
				if rpmtics > 87 then
					v.drawFill(x+66, y+10, 24, 11, 133)
				else
					v.drawFill(x+66, y+10, (rpmtics - 64), 11, 133)
					local transparency = (rpm%RPMTIC)/(RPMTIC/10)
					v.draw(x + 2 + rpmtics, y+10, v.cachePatch("HUDSPD3"), flash[transparency])
				end
			end
		end
	end
	
	//Draw Speed
	if tenthspeedometer.value == 0 then
		if tenthspeed > 4 then wholespeed = $ + 1 end
		speedtext = tostring(wholespeed)
	else
		speedtext = wholespeed .. "." .. tenthspeed
	end
	local speedx = 62 + x - (string.len(speedtext) * 12)
	drawMKtext(v, speedtext, speedx, y+22, flags)
	v.drawString(x+64, y+28, typetext, flags, "left")
end

local function drawBattleManiaTimer(v, p, timertime, flags, x, y, infinite)
	x = $ or 160
	y = $ or 5
	
	if infinite then
		v.draw(x-9, y+16, v.cachePatch("R_NUM_IN"), flags)
	elseif server.SPBArunning and leveltime >= TIMEFORGO then
		if (p.realtime % 10) < 5 then 
			drawManiaTime(v, timertime, x+1, y+16, flags, REDTEXT)
		else
			drawManiaTime(v, timertime, x+1, y+16, flags)
		end
	elseif daytonakart.firstblood.enabled and not daytonakart.firstblood.blooddrawn then
		drawManiaTime(v, timertime, x+1, y+16, flags, REDTEXT)
	elseif p.arcade.extendflash > 0 and (p.arcade.extendflash % 10) < 5 then
		drawManiaTime(v, timertime, x+1, y+16, flags, GREENTEXT)
	elseif (timertime < 10) and ((p.realtime % 10) < 5) then
		drawManiaTime(v, timertime, x+1, y+16, flags, REDTEXT)
	else
		drawManiaTime(v, timertime, x+1, y+16, flags)
	end
end

local function drawBattleManiaSpeed(v, p, flags, x, y, maxHud)
	if not (p and p.valid) then return end
	if p.speed == nil or p.kartweight == nil or p.kartspeed == nil then return end
	local rpm = 1000 + FixedDiv(FixedMul(FixedDiv(p.speed, mapheaderinfo[gamemap].mobj_scale), (baseRPM[p.kartweight] - 1000)), basemaxspeed[p.kartspeed])
	//Do custom RPM checks for during the start of a race here
	if leveltime <= TIMEFORGO then
		rpm = boostchargerpm(p.kartstuff[k_boostcharge], 8000, 10000)
	elseif server.SPBArunning then
		rpm = 1000 + FixedDiv(FixedMul(FixedDiv(p.speed, mapheaderinfo[gamemap].mobj_scale), (baseRPM[p.kartweight + 8] - 1000)), basemaxspeed[p.kartspeed])
	end
	
	x = $ or 160
	y = $ or 5
	
	local speedflags = flags & (V_SNAPTOTOP|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_SNAPTORIGHT)
	
	local rpmstage = min((rpm/1000), 11)
	local wholespeed
	local tenthspeed
	local typetext
	local speedtext
	local speedx = x + 40
	wholespeed, tenthspeed, typetext = convertspeed(p.speed, customspeedometer.value, mapheaderinfo[gamemap].mobj_scale)
	if tenthspeedometer.value == 0 then
		if tenthspeed > 4 then wholespeed = $ + 1 end
		speedtext = tostring(wholespeed) .. " " .. typetext
	else
		speedtext = wholespeed .. "." .. tenthspeed .. " " .. typetext
		speedx = $ + 12
	end
	if string.len(typetext) == 3 then speedx = $ - 8 end
	v.draw(x, y, v.cachePatch("S_REV_"..rpmstage), flags, ((rpmstage > 8) and v.getColormap(0, SKINCOLOR_RED)) or (((rpmstage > 5) and (rpmstage <= 8)) and v.getColormap(0, SKINCOLOR_YELLOW)) or (((rpmstage > 1) and (rpmstage <=5)) and v.getColormap(0, SKINCOLOR_EMERALD)) or v.getColormap(0, SKINCOLOR_COBALT))
	local transparency = (rpm%1000)/100
	if rpmstage < 11 then
		v.draw(x, y, v.cachePatch("S_MID_"..(rpmstage + 1)), speedflags|flash[transparency], ((rpmstage > 8) and v.getColormap(0, SKINCOLOR_RED)) or (((rpmstage > 5) and (rpmstage <= 8)) and v.getColormap(0, SKINCOLOR_YELLOW)) or (((rpmstage > 1) and (rpmstage <=5)) and v.getColormap(0, SKINCOLOR_EMERALD)) or v.getColormap(0, SKINCOLOR_COBALT))
	end
	if maxHud then
		drawLRMAXNum(v, padTimerZero(wholespeed), x+26, y+24, flags, YELLOWTEXT, false, "right")
		drawNewString(v, "LRMT", typetext, x+26, y+36, flags)
	else
		v.drawString(speedx, y+36, speedtext, flags, "right")
	end
end

local function drawBattleManiaSpeedTimer(v, p, timertime, flags, x, y, infinite)
	drawBattleManiaSpeed(v, p, flags, x, y)
	drawBattleManiaTimer(v, p, timertime, flags, x, y, infinite)
end

local function drawTATimer(v, p, xmid, y, flags)
	if not (p and p.valid) then return end
	local littletime = nil
	local littletimestr = "--:--.--"
	local medal = 4
	local littletimecolflag = V_GRAYMAP
	xmid = $ or 160
	y = $ or 50
	if taTimes[gamemap] then
		for i = 1, 3
			if p.realtime < taTimes[gamemap][i] then
				littletime = taTimes[gamemap][i] - p.realtime
				littletimecolflag = 0
				littletimestr = padTimerZero(G_TicsToMinutes(littletime, true)) .. ":" .. padTimerZero(G_TicsToSeconds(littletime)) .. "." ..  padTimerZero(G_TicsToCentiseconds(littletime))
				medal = i
				break
			end
		end
	end
	local medalpatch = ({
		[1] = v.cachePatch("GOTITA"),
		[2] = v.cachePatch("GOTITB"),
		[3] = v.cachePatch("GOTITF"),
		[4] = v.cachePatch("NEEDIT")
	}) [medal]
	
	if littletimecolflag == 0 then
		if p.exiting then
			littletimecolflag = V_GREENMAP
		elseif (littletime < 10*TICRATE) and ((p.realtime % 8) >= 4) then
			littletimecolflag = V_REDMAP
		elseif (littletime >= 10*TICRATE) and (littletime <= 30*TICRATE) and ((p.realtime % 16) >= 8) then
			littletimecolflag = V_YELLOWMAP
		end
	end
	v.drawString(xmid, y, littletimestr, flags|littletimecolflag, "center")
	v.drawScaled((xmid + (4*string.len(littletimestr)))*FRACUNIT, y*FRACUNIT, FRACUNIT/2, medalpatch, flags)
	
end

local function drawWarioLandSpeed(v, p, flags)
	if not (p and p.valid) then return end
	local wholespeed
	local tenthspeed
	local typetext
	local speedtext
	local speedx
	wholespeed, tenthspeed, typetext = convertspeed(p.speed, customspeedometer.value, mapheaderinfo[gamemap].mobj_scale)
	if tenthspeedometer.value == 0 then
		if tenthspeed > 4 then wholespeed = $ + 1 end
		speedx = 50 - (string.len(tostring(wholespeed)) * 9)
		if splitscreen then
			drawSmallWarioLandNumber(v, wholespeed, speedx, 72, flags)
		else
			drawSmallWarioLandNumber(v, wholespeed, speedx, 172, flags)
		end
	else
		speedx = 32 - (string.len(tostring(wholespeed)) * 9)
		if splitscreen then
			drawSmallWarioLandNumber(v, wholespeed, speedx, 72, flags)
			drawLetterScaled(v, "WTMR", ".", 32*FRACUNIT, 72*FRACUNIT, FRACUNIT/2, flags)
			drawLetterScaled(v, "WTMR", tenthspeed, 41*FRACUNIT, 72*FRACUNIT, FRACUNIT/2, flags)
		else
			drawSmallWarioLandNumber(v, wholespeed, speedx, 172, flags)
			drawLetterScaled(v, "WTMR", ".", 32*FRACUNIT, 172*FRACUNIT, FRACUNIT/2, flags)
			drawLetterScaled(v, "WTMR", tenthspeed, 41*FRACUNIT, 172*FRACUNIT, FRACUNIT/2, flags)
		end
	end
	if splitscreen then
		v.drawString(52, 78, typetext, flags, "left")
	else
		v.drawString(52, 178, typetext, flags, "left")
	end
end

local function handlebumperhealth(p)
	if not p.arcade then return end
	local currentbumperhealth = p.kartstuff[k_bumper]
	local priorbumperhealth = p.arcade.lastbumphealth or 0
	local bumplag = p.arcade.bumplag or 0
	if currentbumperhealth ~= priorbumperhealth then
		bumplag = $ + ((priorbumperhealth - currentbumperhealth) * 4)
		p.arcade.lastbumphealth = currentbumperhealth
	elseif bumplag ~= 0 and ((p.realtime % 5) == 0) then
		bumplag = $ + ($ / abs($))
	end
	p.arcade.bumplag = bumplag
end

local function drawWarioLandHP(v, p, flags, x, y)
	if not (p and p.valid) then return end
	if not ((hpmod and hpmod.running) or (gametype & GT_MATCH)) then return end
	if (hpmod and hpmod.running) and (not ((hpmod.maxhp and p.hpmod)) or hpmod_showbar) then return end
	
	local barxpos = x or 1
	local textxpos
	local barypos = y or 160
	local textypos = barypos - 1
	
	local health
	local hpstep
	local hpstepcarry
	local regenhealth
	local rhpstep
	local latenthealth
	local lhpstep
	local healthstring
	
	local maxhplen = 49
	local hpunits = 10
	
	if (gametype & GT_MATCH) and (not hpmod) then
		hpunits = min(max(daytonakart.maxbumperhealth, p.kartstuff[k_bumper]),12)
		maxhplen = (hpunits * 5) - 1
		textxpos = barxpos + 6 + maxhplen
		health = min(p.kartstuff[k_bumper], daytonakart.maxbumperhealth)
		hpstep = health*4
		hpstepcarry = 0
		if hpstep >= 4 then 
			if hpstep%4 == 0 then
				hpstep = $ + ((hpstep-1)/4)
			else
				hpstep = $ + (hpstep/4)
			end
		end
		regenhealth = min(p.kartstuff[k_bumper], hpunits)
		latenthealth = health
		rhpstep = regenhealth*4
		if rhpstep >= 4 then 
			if rhpstep%4 == 0 then
				rhpstep = $ + ((rhpstep-1)/4)
			else
				rhpstep = $ + (rhpstep/4)
			end
		end
		lhpstep = hpstep
		healthstring = p.kartstuff[k_bumper] .. "BP"
		if p.kartstuff[k_comebackpoints] > 0 then healthstring = $ .. ", " .. p.kartstuff[k_comebackpoints] .. "CP" end
	else
		health = p.hpmod.hp
		textxpos = barxpos + 55
		hpstep = FixedInt(FixedDiv(health*40, hpmod.maxhp))
		hpstepcarry = ((health*40)%hpmod.maxhp > 0) and 1 or 0
		if hpstep >= 4 then 
			if hpstep%4 == 0 then
				if hpstepcarry then hpstepcarry = $ + 1 end
				hpstep = $ + ((hpstep-1)/4)
			else
				hpstep = $ + (hpstep/4)
			end
		end
		regenhealth = p.hpmod.minhp
		rhpstep = FixedInt(FixedDiv(regenhealth*40, hpmod.maxhp))
		if rhpstep >= 4 then rhpstep = $ + ((rhpstep-1) / 4) end
		latenthealth = p.hpmod.laghp
		lhpstep = FixedInt(FixedDiv(latenthealth*40, hpmod.maxhp))
		if lhpstep >= 4 then lhpstep = $ + ((lhpstep-1) / 4) end
		healthstring = health .. "HP"
		if p.kartstuff[k_comebackpoints] > 0 then healthstring = $ .. ", " .. p.kartstuff[k_comebackpoints] .. "CP" end
	end
	
	dkartdebug.hp = hpstep
	dkartdebug.regen = rhpstep
	dkartdebug.latent = lhpstep
	
	local temphpstep = hpstep
	local xoff = 0
	local s = 1
	local i = 1
	while temphpstep ~= 0 do
		local bit = temphpstep&s
		temphpstep = temphpstep&!s
		if bit then
			v.draw(barxpos + xoff, barypos, v.cachePatch("WLKHPU"..i), flags, v.getColormap(0, SKINCOLOR_GREEN))
			xoff = $+s
		end
		i = $+1
		s = $<<1
	end
	
	if lhpstep > hpstep then
		hpstepcarry = 0
		temphpstep = lhpstep - hpstep
		if temphpstep > (maxhplen - xoff) then temphpstep = max(maxhplen - xoff, 0) end
		s = 1
		i = 1
		while temphpstep ~= 0 do
			local bit = temphpstep&s
			temphpstep = temphpstep&!s
			if bit then
				v.draw(barxpos + xoff, barypos, v.cachePatch("WLKHPU"..i), flags, v.getColormap(0, SKINCOLOR_CRIMSON))
				xoff = $+s
			end
			i = $+1
			s = $<<1
		end
	end
	
	if rhpstep > hpstep then
		hpstepcarry = 0
		temphpstep = rhpstep - hpstep
		if temphpstep > (maxhplen - xoff) then temphpstep = max(maxhplen - xoff, 0) end
		s = 1
		i = 1
		while temphpstep ~= 0 do
			local bit = temphpstep&s
			temphpstep = temphpstep&!s
			if bit then
				v.draw(barxpos + xoff, barypos, v.cachePatch("WLKHPU"..i), flags, v.getColormap(0, SKINCOLOR_SAPPHIRE))
				xoff = $+s
			end
			i = $+1
			s = $<<1
		end
	end
	
	if hpstepcarry > 0 then
		v.draw(barxpos + xoff + (hpstepcarry - 1), barypos, v.cachePatch("WLKHPU1"), flags, v.getColormap(0, SKINCOLOR_YELLOW))
		xoff = $ + hpstepcarry
	end
	
	temphpstep = max(maxhplen - xoff, 0)
	s = 1
	i = 1
	while temphpstep ~= 0 do
		local bit = temphpstep&s
		temphpstep = temphpstep&!s
		if bit then
			v.draw(barxpos + xoff, barypos, v.cachePatch("WLKHPU"..i), flags, v.getColormap(0, SKINCOLOR_BLACK))
			xoff = $+s
		end
		i = $+1
		s = $<<1
	end
	
	if hpunits == 10 then
		v.draw(barxpos, barypos, v.cachePatch("WLKHPBX"), flags)
	else
		v.draw(barxpos, barypos, v.cachePatch("WLKHPBS"), flags)
		xoff = 4
		local tempmaxhp = hpunits
		s = 1
		i = 1
		while tempmaxhp ~= 0 do
			local bit = tempmaxhp&s
			tempmaxhp = tempmaxhp&!s
			if bit then
				v.draw(barxpos + xoff, barypos, v.cachePatch("WLKHPB"..i), flags, v.getColormap(0, SKINCOLOR_BLACK))
				xoff = $+(s*5)
			end
			i = $+1
			s = $<<1
		end
	end
	
	local textxol
	if hpstep < 4 then 
		textxol = V_REDMAP
	elseif ((hpstep * 4) < hpunits) or ((health == 1) and (hpunits ~= 1)) then
		textxol = V_YELLOWMAP
	else
		textxol = V_GREENMAP
	end
	
	v.drawString(textxpos, textypos, healthstring, flags|textxol)
end

local function drawLRMAXPlace(v, p, n, numplayers, flags)
	local pxpos = 310
	local txpos = 300
	local ypos = 170
	local placetext = tostring(padTimerZero(p.kartstuff[k_position]))
	local patch = v.cachePatch("LRMPL"..placetext)
	if (p.exiting and (p.pflags&PF_TIMEOVER)) or (p.arcade.extendflash < 0) then
		patch = v.cachePatch("LRMPDNF")
	end
	if numplayers == 1 then //Single Player
		hud.disable("freeplay") 
	end
	if splitscreen then
		ypos = 70
		pxpos = 70
	end
	v.draw(pxpos, ypos, patch, flags)
	if not daytonakart.lrmax then return end
	local spoints = p.score
	local inplayers = 0
	for play in players.iterate do
		if play.valid then
			if not play.spectator then
				inplayers = $ + 1
			end
		end
	end
	if not ((p.arcade.timeover and p.arcade.extendflash < 0) or (hpmod and hpmod.running and (p.pflags & PF_TIMEOVER))) then
		spoints = $ + (inplayers - p.kartstuff[k_position])
	end
	local spointsText = tostring(spoints) .. " (" .. tostring(p.score) .. ") S.POINTS"
	drawNewString(v, "LRMT", spointsText, pxpos, ypos - 8, flags, nil, "right")
end

local function drawplace(v, p, n, numplayers, flags, color)
	if not (p and p.valid) then return end
	if (SPLITS and Splits_Runtype()) then return end
	if daytonakart.hud == LRMAXHUD then
		drawLRMAXPlace(v, p, n, numplayers, flags)
		return
	end
	local pxpos = 270
	local txpos = 300
	local ypos = 170
	local placetext = tostring(p.kartstuff[k_position])
	local placefont = "TMER"
	if (daytonakart.hud == 2) or (daytonakart.hud == 4) then placefont = "WTMR" end
	if server.SPBArunning then
		if server.SPBAwin then
			placefont = $ .. "G"
		elseif server.SPBAdone or (p.realtime % 10) < 5 then 
			placefont = $ .. "R"
		else
			placefont = $ .. "Y"
		end
	elseif color == REDTEXT then placefont = $ .. "R"
	elseif color == GREENTEXT then placefont = $ .. "G"
	elseif color == YELLOWTEXT then placefont = $ .. "Y" end
	if numplayers == 1 then //Single Player
		hud.disable("freeplay") 
	end
	if daytonakart.hud == 2 or daytonakart.hud == 4 then
		pxpos = 262
		ypos = $ - 4
		local positiontext = "TH"
		if p.kartstuff[k_position] == 1 then positiontext = "ST" end
		if p.kartstuff[k_position] == 2 then positiontext = "ND" end
		if p.kartstuff[k_position] == 3 then positiontext = "RD" end
		if p.kartstuff[k_position] < 10 then
			if numplayers > 9 and leadingzero.value == 1 then
				placetext = "0" .. $
			else
				pxpos = $ + 18
			end
		end
		if splitscreen then
			pxpos = 5 + (((numplayers > 9) and (p.kartstuff[k_position] < 10) and (leadingzero.value == 0)) and 9 or 0)
			txpos = 17 + (numplayers > 9 and 9 or 0)
			ypos = 83
			v.drawString(txpos, ypos, positiontext, flags)
			drawScaledFontString(v, placefont, placetext, pxpos*FRACUNIT, ypos*FRACUNIT, 9*FRACUNIT, FRACUNIT/2, flags)
		else
			v.drawString(txpos, ypos, positiontext, flags) 
			drawFontString(v, placefont, placetext, pxpos, ypos, 18, flags)
		end
	else
		if numplayers > 9 then //10+ Players
			pxpos = $ - 36
			txpos = $ - 18
			if p.kartstuff[k_position] < 10 then 
				if leadingzero.value == 0 then
					pxpos = $ + 9
				else
					placetext = "0" .. $
				end
			end
		end
		if splitscreen then
			pxpos = 5 + (((numplayers > 9) and (p.kartstuff[k_position] < 10) and (leadingzero.value == 0)) and 9 or 0)
			txpos = 20 + (numplayers > 9 and 9 or 0)
			ypos = 85
			v.drawString(txpos - (3 + (v.stringWidth("PLACE", flags, "small")/2)) , ypos - 4, "PLACE", flags, "small")
			drawScaledFontString(v, placefont, placetext, pxpos*FRACUNIT, ypos*FRACUNIT, 9*FRACUNIT, FRACUNIT/2, flags)
			drawLetterScaled(v, "MKFNT", "/", (txpos - 6)*FRACUNIT, (ypos + 4)*FRACUNIT, FRACUNIT/2, flags)
			drawScaledFontString(v, "TMER", tostring(numplayers), txpos*FRACUNIT, ypos*FRACUNIT, 9*FRACUNIT, FRACUNIT/2, flags)
		else
			v.drawString(txpos - 6 , ypos - 8, "PLACE", flags, "center")
			drawFontString(v, placefont, placetext, pxpos, ypos, 18, flags)
			drawMKtext(v, "/", txpos - 12, ypos + 7, flags)
			drawFontString(v, "TMER", tostring(numplayers), txpos, ypos, 18, flags)
		end
	end
end

local function drawWanganSPBars(v, p, rightside, small, barx, bary, flags)
	if not (p and p.valid) then return end
	if not ((hpmod and hpmod.running) or (gametype & GT_MATCH)) then return end
	if (hpmod and hpmod.running) and (not ((hpmod.maxhp and p.hpmod)) or hpmod_showbar) then return end
	
	local health
	local hpunits
	local regenhealth
	local latenthealth
	local healthstring
	local healthwarn = false
	
	if (gametype & GT_MATCH) and (not (hpmod and hpmod.running)) then
		hpunits = max(daytonakart.maxbumperhealth, p.kartstuff[k_bumper])
		health = p.kartstuff[k_bumper]
		regenhealth = health
		latenthealth = health
		healthstring = health .. "BP"
		if showMaxHP.value == 1 then healthstring = health .. " / " .. daytonakart.maxbumperhealth .. "BP" end
		if ((health == 1) and (hpunits > 1)) or ((hpunits / 5) >= health) then healthwarn = true end
	else
		hpunits = hpmod.maxhp
		health = p.hpmod.hp
		regenhealth = p.hpmod.minhp
		latenthealth = p.hpmod.laghp
		healthstring = health .. "HP"
		if showMaxHP.value == 1 then healthstring = health .. " / " .. hpunits .. "HP" end
		if (health <= 20) or ((hpunits / 5) >= health) then healthwarn = true end
	end
	
	barx = ($ ~= nil and $) or (rightside and 110) or (210)
	bary = ($ ~= nil and $) or (180)
	
	local displaysp = max((latenthealth * 100) / hpunits, 0) 
	local playersp = max((health * 100) / hpunits, 0)
	local healsp = max((regenhealth * 100) / hpunits, 0)
	
	local barname = "WM_HP"
	if rightside then
		barname = $ .. "R"
	else
		barname = $ .. "L"
	end
	if small then
		displaysp = $ / 2
		healsp = $ / 2
		barname = $ .. "S"
	else
		barname = $ .. "B"
	end
	v.draw(barx, bary, v.cachePatch(barname.."E"), flags) --
	
	local tempsp = max(displaysp, 0)
	local xoff = ((not rightside) and (-tempsp)) or 0
	local s = 1
	local i = 1
	local barcolourmap
	local regencolourmap
	if latenthealth > health then
		barcolourmap = v.getColormap(0, SKINCOLOR_ORANGE)
		regencolourmap = v.getColormap(0, SKINCOLOR_YELLOW)
	elseif healthwarn and ((p.realtime % 10) < 5) then
		barcolourmap = v.getColormap(0, SKINCOLOR_RED)
		regencolourmap = v.getColormap(0, SKINCOLOR_SALMON)
	else
		barcolourmap = v.getColormap(0, SKINCOLOR_BLUE)
		regencolourmap = v.getColormap(0, SKINCOLOR_AQUA)
	end
	while tempsp ~= 0 do
		local bit = tempsp&s
		tempsp = tempsp&!s
		if bit then
			v.draw(barx + xoff, bary,  v.cachePatch("WM_HPB"..i), flags, barcolourmap)
			xoff = $+s
		end
		i = $+1
		s = $<<1
	end
	if regenhealth > health then
		if not rightside then xoff = -healsp end
		tempsp = healsp - displaysp
		i = 1
		s = 1
		while tempsp ~= 0 do
			local bit = tempsp&s
			tempsp = tempsp&!s
			if bit then
				v.draw(barx + xoff, bary,  v.cachePatch("WM_HPB"..i), flags, regencolourmap)
				xoff = $+s
			end
			i = $+1
			s = $<<1
		end
	end
	if not rightside then
		v.drawString(barx - 2, bary + 2, healthstring, flags|(((health == 0) or (healthwarn and ((p.realtime % 10) >= 5))) and V_REDMAP or 0), "small-right")
	else
		v.drawString(barx + 2, bary + 2, healthstring, flags|(((health == 0) or (healthwarn and ((p.realtime % 10) >= 5))) and V_REDMAP or 0), "small")
	end
end

local function drawDaytonaHP(v, p, flags, x, y)
	if not (p and p.valid) then return end
	if not ((hpmod and hpmod.running) or (gametype & GT_MATCH)) then return end
	if (hpmod and hpmod.running) and (not ((hpmod.maxhp and p.hpmod)) or hpmod_showbar) then return end
	
	if preferwanganbar.value == 1 and (not splitscreen) then
		drawWanganSPBars(v, p, false, false, nil, nil, flags)
		return
	end
	
	--Get the position of our health bar
	x = $ or 160
	y = $ or 195
	local textx = x
	local texty = y - 21
	
	local hpunits
	local health
	local hpstep
	local regenhealth
	local rhpstep
	local hppatch
	local hptext = 0
	
	--Get the details for the health bar
	if (gametype & GT_MATCH) and (not (hpmod and hpmod.running)) then
		hpunits = max(daytonakart.maxbumperhealth, p.kartstuff[k_bumper])
		health = min(p.kartstuff[k_bumper], daytonakart.maxbumperhealth)
		regenhealth = p.kartstuff[k_bumper]
		hppatch = v.cachePatch("DHPT_BP")
		hptext = regenhealth
		if showMaxHP.value == 1 then hptext = $ .. "/" .. daytonakart.maxbumperhealth end
	else
		hpunits = hpmod.maxhp
		health = p.hpmod.hp
		regenhealth = p.hpmod.minhp
		hppatch = v.cachePatch("DHPT_HP")
		hptext = health
		if showMaxHP.value == 1 then hptext = $ .. "/" .. hpunits end
	end
	
	--Get the percentage steps for hp and rhp
	hpstep = min(FixedInt(FixedDiv(health*100, hpunits)), 100)
	rhpstep = min(FixedInt(FixedDiv(regenhealth*100, hpunits)), 100)
	
	dkartdebug.hp = hpstep
	dkartdebug.regen = rhpstep
	
	--Next, get the colour for the health bar
	local healthbarcol
	local healthbartextcol
	if (hpstep <= 20) or ((health == 1) and (hpunits > 1)) or (server.SPBArunning and leveltime >= TIMEFORGO) then
		if (server.SPBArunning and leveltime >= TIMEFORGO and (p.realtime % 10 >= 5)) then
			healthbarcol = v.getColormap(0, SKINCOLOR_YELLOW)
		else
			healthbarcol = v.getColormap(0, SKINCOLOR_CRIMSON)
		end
		healthbartextcol = ((p.realtime % 10 < 5) or (hpstep == 0)) and V_REDMAP or V_YELLOWMAP
	elseif (hpstep <= 50) or ((health == 2) and (hpunits > 2)) then
		healthbarcol = v.getColormap(0, SKINCOLOR_YELLOW)
		healthbartextcol = V_YELLOWMAP
	else
		healthbarcol = v.getColormap(0, SKINCOLOR_GREEN)
		healthbartextcol = V_GREENMAP
	end
	
	--Now split the steps into 10s and units
	local basebar = hpstep / 10
	local basebarpen = hpstep % 10
	local regenbar = rhpstep / 10
	local regenbarpen = rhpstep % 10
	local penflags = flags & (V_SNAPTOTOP|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_SNAPTORIGHT)
	
	--Now draw the health bar
	v.draw(x, y, v.cachePatch("DHPB_" .. basebar), flags, healthbarcol)
	if (basebarpen > 0) and (rhpstep <= hpstep) then
		v.draw(x, y, v.cachePatch("DHPF_" .. basebar + 1), penflags|flash[basebarpen], healthbarcol)
	elseif (rhpstep > hpstep) then
		healthbarcol = v.getColormap(0, SKINCOLOR_SAPPHIRE)
		healthbartextcol = V_BLUEMAP
		if regenbar > basebar then
			local i = regenbar - basebar
			while i > 0 do
				i = $ - 1
				v.draw(x, y, v.cachePatch("DHPF_" .. regenbar - i), flags, healthbarcol)
			end			
		end
		v.draw(x, y, v.cachePatch("DHPF_" .. regenbar + 1), penflags|flash[regenbarpen], healthbarcol)
	end
	
	--Finally, draw the HP/BP string, plus a value of the current health inside the bar
	v.draw(x, y, hppatch, flags, healthbarcol)
	v.drawString(textx, texty, hptext, flags|healthbartextcol, "center")
end

addHook("NetVars", function(network)
	endtimer = network($)
	maptimes = network($)
	setmaps = network($)
	daytonakart.active = network($)
	daytonakart.diff = network($)
	daytonakart.diffsuff = network($)
	daytonakart.timeover = network($)
	daytonakart.topercent = network($)
	daytonakart.torate = network($)
	daytonakart.todam = network($)
	daytonakart.sneakermode = network($)
	daytonakart.startmod = network($)
	daytonakart.lapmod = network($)
	daytonakart.maxbumperhealth = network($)
	daytonakart.firstblood = network($)
	daytonakart.lrmax = network($)
	daytonakart.explosiveKO = network($)
end)

addHook("MapChange", do
	endtimer = 0
	daytonakart.active = (arcadeon.value > 0)
	daytonakart.lrmax = (lunarRayMAX.value > 0)
end)

addHook("MapLoad", do
	if not (gametype & GT_MATCH) then
		firstloadmap(gamemap)
		daytonakart.active = (arcadeon.value > 0)
		daytonakart.lrmax = (lunarRayMAX.value > 0)
		if daytonakart.lrmax or mapheaderinfo[gamemap].forcelrmaxhud then
			daytonakart.hud = LRMAXHUD
		elseif mapheaderinfo[gamemap].forcedefaulthud then
			daytonakart.hud = 1
		elseif mapheaderinfo[gamemap].forcewariohud then
			daytonakart.hud = WARIOLANDHUD
		elseif mapheaderinfo[gamemap].forcemaniahud then
			daytonakart.hud = BATTLEMANIAHUD
		elseif mapheaderinfo[gamemap].forcepizzahud then
			daytonakart.hud = PIZZATOWERHUD
		elseif mapheaderinfo[gamemap].forcewanganhud then
			daytonakart.hud = WANGANHUD
		elseif mapheaderinfo[gamemap].forcehud then
			local newhud = tonumber(mapheaderinfo[gamemap].forcehud)
			if (newhud < 1) or (newhud > 6) then newhud = hudtype.value end
			daytonakart.hud = newhud
		else
			daytonakart.hud = hudtype.value
		end
		if daytonakart.lrmax then
			daytonakart.sneakermode = 0 --Or 3
			daytonakart.timeover = 0 --Health is not drained here
			daytonakart.topercent = 1
			daytonakart.torate = 35
			daytonakart.todam = 1
			daytonakart.diff = (((difficulty.value < 0) or (difficulty.value == 69)) and difficulty.value) or -10 --Custom or Hard+ only
			daytonakart.diffsuff = "LRMAX"
			daytonakart.extimemod = 8
			daytonakart.explosiveKO = 0
			daytonakart.startmod = min(starttimermod.value, 0) --Start timer mod can not be a time increase
			daytonakart.lapmod = min(laptimermod.value, 0) --Ditto for the Lap timer mod
		else
			daytonakart.sneakermode = sneakeronly.value
			daytonakart.timeover = hpmodtimeover.value
			if timeoverdiffflag.value then
				daytonakart.topercent = 1
				daytonakart.torate = timeoverdiffdefault[daytonakart.diff]
				daytonakart.todam = 1
			else
				daytonakart.topercent = timeoverpercent.value
				daytonakart.torate = timeoverrate.value
				daytonakart.todam = timeoverdam.value
			end
			daytonakart.diff = difficulty.value
			if splitsmod and daytonakart.diff == 69 then daytonakart.diff = 0 end --No custom difficulty in Split mode
			daytonakart.diffsuff = DIFFSUFF[daytonakart.diff]
			daytonakart.extimemod = extratimemod.value
			daytonakart.explosiveKO = explosiveKO.value
			daytonakart.startmod = starttimermod.value
			daytonakart.lapmod = laptimermod.value
		end
		daytonakart.firstblood.enabled = false
		if modeattacking then 
			daytonakart.hud = -$
			daytonakart.diff = 0
			daytonakart.diffsuff = DIFFSUFF[daytonakart.diff]
			daytonakart.timeover = 0
			daytonakart.active = 1
			COM_BufInsertText(server, "arcade_compathud off")
			for m in thinkers.iterate("mobj")
				if m and m.valid and m.type == MT_RANDOMITEM
					m.state = S_INVISIBLE
					m.tics = 1
					m.flags = MF_NOBLOCKMAP
				end
			end
		elseif daytonakart.active and (daytonakart.sneakermode == 2) then
			for m in thinkers.iterate("mobj")
				if m and m.valid and m.type == MT_RANDOMITEM
					m.state = S_INVISIBLE
					m.tics = 1
					m.flags = MF_NOBLOCKMAP
				end
			end
		end
		if daytonakart.active then
			COM_BufInsertText(server, "karteliminatelast off")
			COM_BufInsertText(server, "countdowntime 600")
			for p in players.iterate do
				startset(p, gamemap)
			end
		end
	else -- battle
		daytonakart.active = (arcadeon.value > 0)
		if mapheaderinfo[gamemap].forcedefaulthud then
			daytonakart.hud = 1
		elseif mapheaderinfo[gamemap].forcewariohud then
			daytonakart.hud = WARIOLANDHUD
		elseif mapheaderinfo[gamemap].forcemaniahud then
			daytonakart.hud = BATTLEMANIAHUD
		elseif mapheaderinfo[gamemap].forcepizzahud then
			daytonakart.hud = PIZZATOWERHUD
		elseif mapheaderinfo[gamemap].forcewanganhud then
			daytonakart.hud = WANGANHUD
		elseif mapheaderinfo[gamemap].forcelrmaxhud then
			daytonakart.hud = LRMAXHUD
		elseif mapheaderinfo[gamemap].forcehud then
			local newhud = tonumber(mapheaderinfo[gamemap].forcehud)
			if (newhud < 1) or (newhud > 6) then newhud = hudtype.value end
			daytonakart.hud = newhud
		else
			daytonakart.hud = hudtype.value
		end
		if not ((daytonakart.hud == WARIOLANDHUD) or (daytonakart.hud == PIZZATOWERHUD) or (daytonakart.hud == WANGANHUD)) then
			daytonakart.hud = BATTLEMANIAHUD
		end
		daytonakart.maxbumperhealth = CV_FindVar("kartbumpers").value or 3
		daytonakart.firstblood.enabled = battlefirstblood.value
		daytonakart.firstblood.timelim = battlefirstbloodtimer.value*TICRATE
		daytonakart.firstblood.blooddrawn = false
		daytonakart.firstblood.drawntime = 0
		if daytonakart.active then
			for p in players.iterate do
				startset(p, gamemap)
			end
		end
	end
end)

local function drawWanganTimer(v, p, timertime, flags, plus, inf, x, y, small)
	x = $ or 160
	y = $ or (small and 10) or 20
	plus = $ or (timertime > 99) or false
	timertime = min($, 99) --Timer time always caps to 99s un Wangen mode
	local timercolor = ((p.arcade.extendflash > 0 and (p.arcade.extendflash % 8) < 4) and v.getColormap(0, SKINCOLOR_EMERALD)) or (server.SPBArunning and p.realtime > 0 and v.getColormap(0, SKINCOLOR_CRIMSOM)) or (plus and v.getColormap(0, SKINCOLOR_GOLD)) or v.getColormap(0, SKINCOLOR_YELLOW)
	
	if small then
		v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT/2, v.cachePatch("WMTMRBAS"), flags, timercolor)
		if not inf then
			local tensec = timertime / 10
			local sec = timertime % 10
			drawLetterScaled(v, "WMTMR", tensec, (x-4)*FRACUNIT, y*FRACUNIT, FRACUNIT/2, flags, timercolor)
			drawLetterScaled(v, "WMTMR", sec, (x+4)*FRACUNIT, y*FRACUNIT, FRACUNIT/2, flags, timercolor)
		end
	else
		v.draw(x, y, v.cachePatch("WMTMRBAS"), flags, timercolor)
		if not inf then
			local tensec = timertime / 10
			local sec = timertime % 10
			drawLetter(v, "WMTMR", tensec, x-8, y, flags, timercolor)
			drawLetter(v, "WMTMR", sec, x+8, y, flags, timercolor)
		end
	end
end

local numplayers

addHook("ThinkFrame", do
	hpbarcheck()
	if (not (gametype & GT_MATCH)) and daytonakart.active then
		local outplayers
		local possoutplayers
		numplayers = 0
		outplayers = 0
		possoutplayers = 0
		for p in players.iterate do
			if not p and p.valid continue end
			if p.spectator then //Make sure spectators can hear the countdown
				if not (mapheaderinfo[gamemap].hasannouncer == true) then
					if leveltime == TIMEFORTHREE then
						S_StartSound(nil,sfx_amsc3,p)
					elseif leveltime == TIMEFORTWO then
						S_StartSound(nil,sfx_amsc2,p)
					elseif leveltime == TIMEFORONE then
						S_StartSound(nil,sfx_amsc1,p)
					elseif leveltime == TIMEFORGO then
						S_StartSound(nil,sfx_amscgo,p)
					end
				elseif leveltime == TIMEFORGO + TICRATE then
					S_StartSound(nil,sfx_amatuw,p)
				end
				continue
			end
			if not p.arcade and leveltime > 26 then startset(p, gamemap) end
			p.kartstuff[k_lapanimation] = 0 //Thanks Lat' for showing me that this is possible.
			if leveltime < 26 then
				continue --Don't do anything during the first few frames as we need to set things up
			elseif leveltime == 26 then
				firstloadmap(gamemap)
				startset(p, gamemap) //Just in case
			elseif (leveltime == TIMEFORTHREE) and not (mapheaderinfo[gamemap].hasannouncer == true) then
				S_StartSound(nil,sfx_amsc3,p)
			elseif (leveltime == TIMEFORTWO) and not (mapheaderinfo[gamemap].hasannouncer == true) then
				S_StartSound(nil,sfx_amsc2,p)
			elseif (leveltime == TIMEFORONE)and not (mapheaderinfo[gamemap].hasannouncer == true) then
				S_StartSound(nil,sfx_amsc1,p)
			elseif leveltime == TIMEFORGO then
				if  not (mapheaderinfo[gamemap].hasannouncer == true) then
					S_StartSound(nil,sfx_amscgo,p)
				end
				if hpmod and hpmod.running and hpmod.maxhp ~= p.arcade.hpcap then
					p.hpmod = {
						hp = hpmod.maxhp,
						minhp = hpmod.maxhp,
						laghp = hpmod.maxhp,
						deathtimer = 0,
						lastlap = 0
					}
					p.arcade.hpcap = hpmod.maxhp
					p.arcade.hpcapped = true
				end
			elseif leveltime == TIMEFORGO + TICRATE then
				S_StartSound(nil,sfx_amatuw,p)
				if hpmod and hpmod.running and not p.arcade.hpcapped then
					p.hpmod = {
						hp = hpmod.maxhp,
						minhp = hpmod.maxhp,
						laghp = hpmod.maxhp,
						deathtimer = 0,
						lastlap = 0
					}
					p.arcade.hpcap = hpmod.maxhp
					p.arcade.hpcapped = true
				end
			elseif leveltime > TIMEFORGO and hpmod and hpmod.running and not p.arcade.hpcapped then
				p.hpmod = {
					hp = hpmod.maxhp,
					minhp = hpmod.maxhp,
					laghp = hpmod.maxhp,
					deathtimer = 0,
					lastlap = 0
				}
				p.arcade.hpcap = hpmod.maxhp
				p.arcade.hpcapped = true
			end
			if p.spectator then continue end
			if p.arcade == nil then startset(p, gamemap) end
			numplayers = $ + 1
			
			if p.exiting then
				outplayers = $ + 1 
				possoutplayers = $ + 1
				if p.arcade.quirplength == 0 then
					p.arcade.quirplength = -1
					S_StartSound(nil,sfx_amgoal,p)
				end
				continue
			end
			
			if hpmod and hpmod.running and (p.pflags & PF_TIMEOVER) then 
				if p.arcade.extendflash > -TIMEOVERLENGTH then p.arcade.extendflash = $ - 1 end
				outplayers = $ + 1
				possoutplayers = $ + 1
				continue
			end
			
			if sneakeronly.value == 3 and (p.kartstuff[k_itemtype] > 3) and (p.kartstuff[k_itemtype] < 13) then
				local olditem = p.kartstuff[k_itemtype]
				local newitem = ITEMCHANGELRMAX[olditem]
				if newitem > 0 then p.kartstuff[k_itemtype] = newitem end
			elseif sneakeronly.value == 1 and (p.kartstuff[k_itemtype] > 3) and (p.kartstuff[k_itemtype] < 13) then
				local olditem = p.kartstuff[k_itemtype]
				local newitem = ITEMCHANGE[olditem]
				if olditem == 10 and sneakerspb.value then newitem = -1 end
				if newitem > 0 then p.kartstuff[k_itemtype] = newitem end
				if p.kartstuff[k_itemamount] >= 4 then //10 Bananas or 4x Orbinauts
					p.kartstuff[k_itemamount] = 3
				elseif p.kartstuff[k_itemamount] == 3 then //Triple Orbinauts/Bananas
					p.kartstuff[k_itemamount] = 2
				elseif p.kartstuff[k_itemamount] == 2 and olditem == 7 then //Twin Jaws
					p.kartstuff[k_itemamount] = 3
				elseif olditem == 9 or olditem == 7 then //Ballhogs or Single Jawz
					p.kartstuff[k_itemamount] = 2
				end
			end
			
			if p.arcade.timelimit == p.realtime and not p.arcade.timeover then //Time Over
				p.arcade.timeover = true
				S_StartSound(nil,sfx_arcko,p)
				if hitfeed and not (daytonakart.lrmax) then
					local patch = "HFEDCK"
					local source = {{nil, nil}, {nil, nil}, nil}
					local victim = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
					if not HF_animIcon[patch] then HF_animIcon[patch] = {6, 3} end
					HF_SendHitMessage(source, victim, patch)
				end
			elseif p.arcade.extendflash < 0 and not (p.arcade.extendflash == -TIMEOVERLENGTH) then
				p.arcade.extendflash = $ - 1
			end
			
			if p.arcade.timeover then
				if hpmod and hpmod.running and daytonakart.timeover then
					if not (p.kartstuff[k_driftboost] or (p.kartstuff[k_growshrinktimer] > 0) or p.kartstuff[k_sneakertimer]) then
						p.kartstuff[k_accelboost] = -(FRACUNIT / 5) //Your engine becomes less effecient if time is over
					end
					if (p.realtime - p.arcade.timelimit)%daytonakart.torate == 0 then --Time to take some damage!
						local dam
						if daytonakart.topercent then
							dam = max((hpmod.maxhp * daytonakart.todam) / 100, 1) --Always do at least 1HP damage
						else
							dam = daytonakart.todam
						end
						if dam > p.hpmod.hp then dam = p.hpmod.hp end
						if rawget(_G, "hpmod_damagehp") then --This allows this to do the damage properly
							hpmod_damagehp(p, dam, {{damagedealer, 0}, {"Time Itself", 0}})
						else --No? Well, this is a 'hack' to do it instead until it's added in
							p.hpmod.hp = $-dam 
						end
						p.arcade.hpcap = $-dam //This damage also damages the HP Cap as well for the player.
						if p.arcade.hpcap < p.hpmod.minhp then p.hpmod.minhp = p.arcade.hpcap end
					end
				else
					p.pflags = $ | PF_STASIS
					possoutplayers = $ + 1
					if p.speed == 0 or (p.rmomx == 0 and p.rmomy == 0) then
						if p.kartstuff[k_itemtype] then --Lose your items if you're out of time and KOed!
							p.kartstuff[k_itemtype] = 0
							p.kartstuff[k_itemamount] = 0
							K_StripItems(p)
						end
						outplayers = $ + 1
						if p.arcade.extendflash > -1 and (not server.SPBAdone) then
							p.arcade.extendflash = -1
							S_ChangeMusic("KRFAIL",true,p)
							if hitfeed then
								local patch = "HFEDCK"
								local source = {{"Time Itself", 0}, {nil, nil}, nil}
								local victim = {{p.name, SKINCOLOR_CRIMSON}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
								if not HF_animIcon[patch] then HF_animIcon[patch] = {6, 5} end
								HF_SendHitMessage(source, victim, patch)
							end
							if SPLITS and Splits_Runtype() and numplayers == 1 then
								p.arcade.autoreset = true
							end
							if daytonakart.explosiveKO then --Explosive KO!
								p.pflags = $|PF_TIMEOVER
								p.lives = 0
								if p.mo then P_DamageMobj(p.mo, nil, nil, 10000) end
								P_FlashPal(p, 1, 10)
								p.exiting = TIMEOVERLENGTH
								p.arcade.quirplength = -1
							end
						end
						continue
					end
				end
			else
				if p.hpmod and p.arcade.hpcap then
					if p.arcade.hpcap < p.hpmod.hp then p.hpmod.hp = p.arcade.hpcap end
					if p.arcade.hpcap < p.hpmod.minhp then p.hpmod.minhp = p.arcade.hpcap end
				end
			end
			
			if (p.laps > p.arcade.lapcheck) and p.arcade.extendflash > -1 then
				p.arcade.lapcheck = $ + 1
				p.arcade.timetoshow = (p.arcade.timelimit - p.realtime) / TICRATE
				if mapheaderinfo[gamemap].noextension or mapheaderinfo[gamemap].arcadeboss then
					p.arcade.numlaps = $ + 1
					p.arcade.quirplength = TICRATE
					if p.arcade.numlaps == 1 then 
						p.arcade.extendflash = FLASHTIME
						if tsrb2kr then
							local doteamtimebonus = true
							local toplap = 0
							for i = 1, #team do
								local teammate = team[i]
								toplap = max($, teammate.laps)
								if teammate == p then continue end
								if teammate.arcade.lapcheck >= p.laps then doteamtimebonus = false end
							end
							if toplap == 1 and doteamtimebonus then
								tsrb2kr.FillUltimate(p, 0, "NO TIME EXTENDS", {V_REDMAP, V_ORANGEMAP}, nil, true) //new definition
							end
						end
					end
				elseif tsrb2kr then
					local team = server.tsr_server.teams[p.tsr.team] //new definition
					local doteamtimebonus = true
					for i = 1, #team do
						local teammate = team[i]
						if teammate == p then continue end
						if teammate.arcade.lapcheck >= p.laps then doteamtimebonus = false end
					end
					if doteamtimebonus then
						for i = 1, #team do
							local teammate = team[i]
							if teammate.arcade.timeover then //Almost about to lose, but crosses the finish line before stopping
								teammate.arcade.timeover = false //Back in the game!
								teammate.arcade.timeincrease = 1
								teammate.arcade.timelimit = (1 + (teammate.realtime / TICRATE)) * TICRATE
							end
							if not (p.arcade.lapcheck == numlaps) then
								teammate.arcade.timelimit = $ + teammate.arcade.bonustime
								teammate.arcade.timeincrease = $ + (teammate.arcade.bonustime / TICRATE)
								teammate.arcade.extendflash = FLASHTIME
							end
							if (tonumber(mapheaderinfo[gamemap].lapcheckpoints) ~= nil) and (p == teammate) then
								if (p.arcade.lapcheck % tonumber(mapheaderinfo[gamemap].lapcheckpoints)) == 0 then
									p.arcade.numlaps = $ + 1
									p.arcade.quirplength = timeextended(p)
								end
							else
								if p ~= teammate then teammate.arcade.teamtimebonus = true end
								if not mapheaderinfo[gamemap].hasannouncer == true
									p.arcade.quirplength = timeextended(p)
								else
									p.arcade.quirplength = TICRATE
								end
							end
						end
						tsrb2kr.FillUltimate(p, 120, "TIME EXTEND!", {V_YELLOWMAP, V_ORANGEMAP}, sfx_arcbt, true) //new definition
					else
						p.arcade.quirplength = max(35, $)
						p.arcade.teamtimebonus = false
					end
				else
					if p.arcade.timeover then //Almost about to lose, but crosses the finish line before stopping
						p.arcade.timeover = false //Back in the game!
						p.arcade.timeincrease = 1
						p.arcade.timelimit = (1 + (p.realtime / TICRATE)) * TICRATE
					end
					if not (p.arcade.lapcheck == numlaps) then
						p.arcade.timelimit = $ + p.arcade.bonustime
						p.arcade.timeincrease = $ + (p.arcade.bonustime / TICRATE)
						p.arcade.extendflash = FLASHTIME
					end
					if tonumber(mapheaderinfo[gamemap].lapcheckpoints) ~= nil then
						if (p.arcade.lapcheck % tonumber(mapheaderinfo[gamemap].lapcheckpoints)) == 0 then
							p.arcade.numlaps = $ + 1
							if not mapheaderinfo[gamemap].hasannouncer == true
								p.arcade.quirplength = timeextended(p)
							else
								p.arcade.quirplength = TICRATE
							end
						end
					else
						if not mapheaderinfo[gamemap].hasannouncer == true
							p.arcade.quirplength = timeextended(p)
						else
							p.arcade.quirplength = TICRATE
						end
					end
				end
			elseif (p.arcade.extendflash > 0) then //Reduce countdown on Lap Bonus
				p.arcade.extendflash = $ - 1
			end
			if (p.arcade.timeincrease > 0) and (p.realtime % UPDATESPEED) == 0 then
				p.arcade.timetoshow = $ + 1
				p.arcade.timeincrease = $ - 1
			end
			if (p.arcade.timeincrease > 0) and (p.realtime % 35) == 0 then
				p.arcade.timetoshow = $ - 1
			end
			
			p.arcade.wariotime = p.arcade.timetoshow
			if (((p.arcade.timelimit - p.realtime) % TICRATE) > 0) and (leveltime > TIMEFORGO) then p.arcade.wariotime = $ + 1 end
			
			if p.arcade.quirplength > 0 then
				p.arcade.quirplength = $ - 1
				if (p.arcade.quirplength == 0) and not p.arcade.teamtimebonus then
					local lapstogo 
					if (tonumber(mapheaderinfo[gamemap].lapcheckpoints) ~= nil) and (not (mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE)) then
						lapstogo = (numlaps/tonumber(mapheaderinfo[gamemap].lapcheckpoints)) - p.arcade.numlaps
					else
						lapstogo = numlaps - p.arcade.lapcheck
					end
					local sfxpack = lapstogosfx
					if (mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE) then sfxpack = legstogosfx end
					if sfxpack[lapstogo] then S_StartSound(nil,sfxpack[lapstogo],p) end
				end
			end
			
			if (p.arcade.timelimit - (30 * TICRATE)) == p.realtime and p.realtime > 0 then
				//Keep an eye on your time!
				S_StartSound(nil,sfx_amlot1,p)
			elseif (p.arcade.timelimit - (13 * TICRATE)) == p.realtime and p.realtime > 0  then
				//Almot out of time!
				S_StartSound(nil,sfx_amlot2,p)
			elseif (p.arcade.timelimit - (10 * TICRATE)) == p.realtime and p.realtime > 0  then
				//Play a warning SFX to give an audio cue that time is about to run out.
				S_StartSound(nil,sfx_arccr,p)
			elseif (p.arcade.timelimit - (10 * TICRATE)) < p.realtime and p.realtime > 0 
				and (p.realtime % (TICRATE)) == 0
				and not (p.arcade.timelimit <= p.realtime) then
				//Time's running out!
				S_StartSound(nil,sfx_arclo,p)
			end
		end
		
		if endtimer > 0 then
			endtimer = $ + 1
			if (SPLITS and Splits_Runtype()) and (endtimer == TIMEOVERLENGTH/2) and (numplayers == 1) then
				for p in players.iterate() do
					if p.exiting then continue end
					p.arcade.autoreset = true
				end
			elseif endtimer > TIMEOVERLENGTH and not modeattacking then
				if not (tsrb2kr or (SPLITS and Splits_Runtype())) then
					G_ExitLevel()
				else
					for p in players.iterate() do
						if p.spectator continue end
						if p.arcade.autoreset then
							Splits_Reset()
							continue
						end
						if p.exiting then continue end
						p.pflags = $|PF_TIMEOVER
						p.lives = 0
						if p.mo then P_DamageMobj(p.mo, nil, nil, 10000) end
						P_FlashPal(p, 1, 10)
						p.exiting = TIMEOVERLENGTH
					end
				end
			end
		elseif outplayers == numplayers and numplayers > 0 then
			endtimer = 1
		elseif possoutplayers == numplayers and numplayers > 0 then
			for p in players.iterate() do
				if p.spectator continue end
				if p.exiting then continue end
				if p.arcade.timelimit + (TIMEOVERLENGTH) < p.realtime then
					if (p.arcade.extendflash > -1) and (not server.SPBAdone) then
						p.arcade.extendflash = -1
						S_ChangeMusic("KRFAIL",true,p)
						if hitfeed then
							local patch = "HFEDCK"
							local source = {{"Time Itself", 0}, {nil, nil}, nil}
							local victim = {{p.name, SKINCOLOR_CRIMSON}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
							if not HF_animIcon[patch] then HF_animIcon[patch] = {6, 5} end
							HF_SendHitMessage(source, victim, patch)
						end
						if SPLITS and Splits_Runtype() and numplayers == 1 then
							p.arcade.autoreset = true
						end
					end
					outplayers = $ + 1
				end
				if outplayers == numplayers and numplayers > 0 then
					endtimer = 1
				end
			end
		end
	else
		for p in players.iterate do //Still do the countdown from the announcer
			if not p.arcade and leveltime > 26 then startset(p, gamemap) end
			if leveltime < 26 then
				continue --Don't do anything during the first few frames as we need to set things up
			elseif leveltime == 26 then
				startset(p, gamemap)
			elseif not (mapheaderinfo[gamemap].hasannouncer == true) then
				if leveltime == TIMEFORTHREE then
					S_StartSound(nil,sfx_amsc3,p)
				elseif leveltime == TIMEFORTWO then
					S_StartSound(nil,sfx_amsc2,p)
				elseif leveltime == TIMEFORONE then
					S_StartSound(nil,sfx_amsc1,p)
				elseif leveltime == TIMEFORGO then
					S_StartSound(nil,sfx_amscgo,p)
				end
			end
			if leveltime == TIMEFORGO + TICRATE then
				S_StartSound(nil,sfx_amatuw,p)
			end
			if (gametype & GT_MATCH) and (daytonakart.active) then
				if hpmod and hpmod.running and not p.arcade.hpcapped then
					p.hpmod = {
						hp = hpmod.maxhp,
						minhp = hpmod.maxhp,
						laghp = hpmod.maxhp,
						deathtimer = 0,
						lastlap = 0
					}
					p.arcade.hpcap = hpmod.maxhp
					p.arcade.hpcapped = true
				end
				if daytonakart.firstblood.enabled and daytonakart.firstblood.blooddrawn and (p.arcade.timelimit == 0) then
					p.arcade.timelimit = daytonakart.firstblood.drawntime + daytonakart.firstblood.timelim
					p.arcade.extendflash = TICRATE*2
				elseif p.arcade.extendflash > 0 then
					p.arcade.extendflash = $ - 1
				end
				if (p.arcade.timelimit - (30 * TICRATE)) == p.realtime and p.realtime > 0 then
					//30 seconds left!
					S_StartSound(nil,sfx_amlot1,p)
				elseif (p.arcade.timelimit - (10 * TICRATE)) == p.realtime and p.realtime > 0  then
					//Play a warning SFX to give an audio cue that time is about to run out.
					S_StartSound(nil,sfx_arccr,p)
				elseif (p.arcade.timelimit - (10 * TICRATE)) < p.realtime and p.realtime > 0 
					and (p.realtime % (TICRATE)) == 0
					and not (p.arcade.timelimit <= p.realtime) then
					//Time's running out!
					S_StartSound(nil,sfx_arclo,p)
				elseif (p.arcade.timelimit <= p.realtime) and daytonakart.firstblood.blooddrawn and not p.exiting then
					S_StartSound(nil,sfx_amgoal,p)
					P_DoPlayerExit(p)
				end
				handlebumperhealth(p)
			end
		end
	end
end)

local function shouldHurt(p)
	return not (p.powers[pw_flashing] > 0 or p.kartstuff[k_squishedtimer] > 0 or p.kartstuff[k_spinouttimer] > 0
		or p.kartstuff[k_invincibilitytimer] > 0 or p.kartstuff[k_growshrinktimer] > 0 or p.kartstuff[k_hyudorotimer] > 0 
		or (G_BattleGametype() and ((p.kartstuff[k_bumper] <= 0 and p.kartstuff[k_comebacktimer]) or p.kartstuff[k_comebackmode] == 1)))
end

--Here we go, let's see if first blood is spilled
addHook("ShouldSpin", function(p, inflictor, source)
	if (not daytonakart.firstblood.enabled) or daytonakart.firstblood.blooddrawn return end --We don't need to check in this case
	if tsrb2kr then return end
	if (source and source.player and (p ~= source.player))
	and not (not source.player.kartstuff[k_invincibilitytimer] and (inflictor and inflictor.player and (source.player.kartstuff[k_sneakertimer] or source.player.kartstuff[k_pogospring])))
		if not shouldHurt(p) then
			K_DoInstashield(p)
			return false
		else
			daytonakart.firstblood.blooddrawn = true
			daytonakart.firstblood.drawntime = source.player.realtime
			source.player.marescore = $ + 2 --First Blood Perk! The first hit is worth 3x the normal score
			print(source.player.name .. " has drawn first blood!")
			for px in players.iterate do
				S_StartSound(nil, sfx_fstbld, px)
			end
		end
	end
	return
end)

addHook("ShouldSquish", function(p, inflictor, source)
	if (not daytonakart.firstblood.enabled) or daytonakart.firstblood.blooddrawn return end --We don't need to check in this case
	if tsrb2kr then return end
	if (source and source.player and (p ~= source.player))
	and not (not source.player.kartstuff[k_invincibilitytimer] and (inflictor and inflictor.player and (source.player.kartstuff[k_sneakertimer] or source.player.kartstuff[k_pogospring])))
		if not shouldHurt(p) then
			K_DoInstashield(p)
			return false
		else
			daytonakart.firstblood.blooddrawn = true
			daytonakart.firstblood.drawntime = source.player.realtime
			source.player.marescore = $ + 2 --First Blood Perk! The first hit is worth 3x the normal score
			print(source.player.name .. " has drawn first blood!")
			for px in players.iterate do
				S_StartSound(nil, sfx_fstbld, px)
			end
		end
	end
	return
end)

addHook("ShouldExplode", function(p, inflictor, source)
	if (not daytonakart.firstblood.enabled) or daytonakart.firstblood.blooddrawn return end --We don't need to check in this case
	if tsrb2kr then return end
	if (source and source.player and (p ~= source.player))
	and not (not source.player.kartstuff[k_invincibilitytimer] and (inflictor and inflictor.player and (source.player.kartstuff[k_sneakertimer] or source.player.kartstuff[k_pogospring])))
		if not shouldHurt(p) then
			K_DoInstashield(p)
			return false
		else
			daytonakart.firstblood.blooddrawn = true
			daytonakart.firstblood.drawntime = source.player.realtime
			source.player.marescore = $ + 2 --First Blood Perk! The first hit is worth 3x the normal score
			print(source.player.name .. " has drawn first blood!")
			for px in players.iterate do
				S_StartSound(nil, sfx_fstbld, px)
			end
		end
	end
	return
end)

addHook("MobjCollide", function(mobj1, mobj2)
	if (not daytonakart.firstblood.enabled) or daytonakart.firstblood.blooddrawn return end --We don't need to check in this case
	if tsrb2kr then return end
	if not mobj2.valid then return end
	local p1, p2 = mobj1.player, mobj2.player

    if mobj2.player then
		if not (shouldHurt(p1) and shouldHurt(p2)) then return end

        if not ((mobj1.z >= mobj2.z and mobj1.z < mobj2.z + mobj2.height)
        or (mobj2.z >= mobj1.z and mobj2.z < mobj1.z + mobj1.height)) then
            return
        end

		if (p1.kartstuff[k_sneakertimer] and p2.kartstuff[k_sneakertimer])
		or not (p1.kartstuff[k_sneakertimer] or p2.kartstuff[k_sneakertimer]) then
			return
		end

        local attacker, victim
        --detect who wins fight
        if p1.kartstuff[k_sneakertimer] > p2.kartstuff[k_sneakertimer] then
            attacker = mobj1
            victim = p2
        else
            attacker = mobj2
            victim = p1
        end
		
		daytonakart.firstblood.blooddrawn = true
		daytonakart.firstblood.drawntime = attacker.player.realtime
		attacker.player.marescore = $ + 2 --First Blood Perk! The first hit is worth 3x the normal score
		print(attacker.player.name .. " has drawn first blood!")
		for px in players.iterate do
			S_StartSound(nil, sfx_fstbld, px)
		end
	end
end, MT_PLAYER)

hud.add(function(v, p, c)
	if (not (gametype & GT_MATCH)) and (not p.spectator) and (p.arcade != nil) and daytonakart.active then
		local timertime
		hud.disable("time") //Done custom
		hud.disable("gametypeinfo") //Also done custom
		hud.disable("speedometer") //Also done custom
		hud.disable("position") //Also done custom
		if server.tsr_server and server.tsr_server.finishstate then return end
		//We don't need this while the results screen is being done
		if abs(daytonakart.hud) == LRMAXHUD then
			timertime = p.arcade.timelimit - p.realtime
		elseif (p.arcade.timeincrease > 0) and not (instaupdate.value == 1) then
			timertime = p.arcade.timetoshow
			if (abs(daytonakart.hud) == WARIOLANDHUD) or (abs(daytonakart.hud) == PIZZATOWERHUD) then timertime = p.arcade.wariotime end
		elseif (leveltime < TIMEFORONE) and not (instaupdate.value == 1) then
			timertime = (p.arcade.timelimit/35) - (max(((TIMEFORONE - leveltime)/(UPDATESPEED*2)), 0) * 5)
		else
			timertime = (p.arcade.timelimit - p.realtime) / 35
			if ((abs(daytonakart.hud) == WARIOLANDHUD) or (abs(daytonakart.hud) == PIZZATOWERHUD) or tsrb2kr or (compathud.value == 1) or  (fndmod and fndmod.active)) 
			and ((((p.arcade.timelimit - p.realtime) / 35) > 0) or ((p.arcade.timelimit > p.realtime) and (p.arcade.timelimit < (p.realtime + 35)))) and (leveltime > (TIMEFORGO+1)) then 
				timertime = $ + 1
			end
		end
		local moretime = false
		if (timertime <= 0) or (p.arcade.timelimit - p.realtime <= 0) or (p.pflags & PF_TIMEOVER) then timertime = 0 end
		if (abs(daytonakart.hud) ~= WARIOLANDHUD) and (abs(daytonakart.hud) ~= PIZZATOWERHUD) and (not tsrb2kr) and not (fndmod and fndmod.active) and (compathud.value == 0) then
			if timertime > 99 and (timercap.value == 1) then //Capped at 99s
				timertime = 99
				moretime = true
			elseif timertime > 150 and (timercap.value == 2) then //Capped at 150s like in Inital D Arcade Stages
				timertime = 150
			elseif timertime > 999 and (timercap.value == 3) then //Capped to 999 like in the original Daytona USA
				timertime = 999
			end
		end
		if splitscreen then
			local n = c.pnum
			if not n then return end
			if (p.arcade.timeover and p.arcade.extendflash < 0)
			or (hpmod and hpmod.running and (p.pflags & PF_TIMEOVER)) then
				local tic = abs(p.arcade.extendflash)
				local timerstring = "0:00"
				if tsrb2kr then
					local flags = tsrb2kr.ReturnSplitFlags(V_SNAPTOTOP|V_SNAPTORIGHT|V_MONOSPACE|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], TSR_IsDisplayPlayer(p))
					if (splitscreen > 1) then
						local strw = v.stringWidth("59:99")
						v.drawString(131-(strw/2), 15, "TIME", flags|V_YELLOWMAP, "center")
						v.drawString(131-(strw/2), 25, timerstring, flags|V_REDMAP, "center")
					else
						v.drawString(249, 27, "TIME", flags|V_YELLOWMAP, "center")
						v.drawString(249, 37, timerstring, flags|V_REDMAP, "center")
					end
				else
					local flags = flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH]|V_MONOSPACE
					local exflags = flags
					
					if splitscreen == 1 then
						if n == 2 then 
							flags = $|V_SPLITSCREEN
						else
							flags = $|V_SNAPTOTOP
						end
						if daytonakart.hud == WARIOLANDHUD then
							drawWarioLandSplitTimer(v, p, 0, 160, 5, flags)
						elseif daytonakart.hud == WANGANHUD then
							drawWanganTimer(v, p, timertime, flags, false, false, nil, 10, true)
						else
							v.drawString(160, 5, "TIME", flags|V_YELLOWMAP, "center")
							v.drawString(160, 15, timerstring, flags|V_REDMAP, "center")
						end
						drawlaps(v, p, n, gamemap, flags | V_SNAPTORIGHT)
						if  n == 1 then
							flags = $ & ~(V_SNAPTOTOP)
						else
							flags = $ | V_SNAPTOBOTTOM
						end
						drawplace(v, p, n, numplayers, flags | V_SNAPTOLEFT, REDTEXT)
					else
						local exflags = flags
						if n < 3 then
							flags = $|V_SNAPTOTOP
						else
							flags = $|V_SPLITSCREEN
							exflags = $|V_SNAPTOBOTTOM|V_SPLITSCREEN
						end
						if n%2 == 0 then
							flags = $|V_HORZSCREEN
							exflags = $|V_SNAPTORIGHT|V_HORZSCREEN
						else
							exflags = $|V_SNAPTOLEFT
						end
						if daytonakart.hud == WARIOLANDHUD then
							drawWarioLandSplitTimer(v, p, 0, 80, 5, flags)
						elseif daytonakart.hud == WANGANHUD then
							drawWanganTimer(v, p, timertime, flags, false, false, 80, 10, true)
						else
							v.drawString(80, 5, "TIME", flags|V_YELLOWMAP, "center")
							v.drawString(80, 15, timerstring, flags|V_REDMAP, "center")
						end
						drawlaps(v, p, n, gamemap, exflags)
					end
				end
			else
				if tsrb2kr then
					local flags = tsrb2kr.ReturnSplitFlags(V_SNAPTOTOP|V_SNAPTORIGHT|V_MONOSPACE|V_HUDTRANS, TSR_IsDisplayPlayer(p))
					local timercolon = ((((p.realtime % TICRATE) < (TICRATE / 2)) or p.exiting) and true) or false 
					local timerstring = secsToTimer(timertime, timercolon)
					local colflag = 0
					if p.exiting then
						if p.kartstuff[k_position] == 1 then
							colflag = V_YELLOWMAP
						elseif p.pflags & PF_TIMEOVER then
							colflag = V_REDMAP
						elseif not K_IsPlayerLosing(p) then
							colflag = V_GREENMAP
						end
					elseif p.arcade.extendflash > 0 and (p.arcade.extendflash % 8) < 4 then
						colflag = V_GREENMAP
					elseif (p.pflags & PF_TIMEOVER) or (not ((timertime > 9) or ((p.realtime % 8) < 4) or (leveltime < TIMEFORONE))) then
						colflag = V_REDMAP
					end
					if (splitscreen > 1) then
						local strw = v.stringWidth("59:99")
						v.drawString(131-(strw/2), 15, "TIME", flags|V_YELLOWMAP, "center")
						v.drawString(131-(strw/2), 25, timerstring, flags|colflag, "center")
					else
						v.drawString(249, 27, "TIME", flags|V_YELLOWMAP, "center")
						v.drawString(249, 37, timerstring, flags|colflag, "center")
					end
				else
					local flags = V_HUDTRANS|V_MONOSPACE
					local col
					local colflag = 0
					local timercolon = (((p.realtime % TICRATE) < (TICRATE / 2) or p.exiting) and true or false) 
					local timerstring = secsToTimer(timertime, timercolon)
					if p.exiting then
						if p.kartstuff[k_position] == 1 then
							col = YELLOWTEXT
							colflag = V_YELLOWMAP
						elseif p.pflags & PF_TIMEOVER then
							col = REDTEXT
							colflag = V_REDMAP
						elseif not K_IsPlayerLosing(p) then
							col = GREENTEXT
							colflag = V_GREENMAP
						end
					elseif p.arcade.extendflash > 0 and (p.arcade.extendflash % 8) < 4 then
						col = GREENTEXT
						colflag = V_GREENMAP
					elseif not ((timertime > 9) or ((p.realtime % 8) < 4) or (leveltime < TIMEFORONE)) then
						col = REDTEXT
						colflag = V_REDMAP
					end
					if splitscreen == 1 then
						if n == 2 then 
							flags = $|V_SPLITSCREEN
						else
							flags = $|V_SNAPTOTOP
						end
						if daytonakart.hud == WARIOLANDHUD then
							drawWarioLandSplitTimer(v, p, 0, 160, 5, flags)
						elseif daytonakart.hud == WANGANHUD then
							drawWanganTimer(v, p, timertime, flags, false, false, nil, 10, true)
						else
							v.drawString(160, 5, "TIME", flags|V_YELLOWMAP, "center")
							v.drawString(160, 15, timerstring, flags|colflag, "center")
						end
						drawlaps(v, p, n, gamemap, flags | V_SNAPTORIGHT)
						if  n == 1 then
							flags = $ & ~(V_SNAPTOTOP)
						else
							flags = $ | V_SNAPTOBOTTOM
						end
						drawplace(v, p, n, numplayers, flags | V_SNAPTOLEFT, col)
					else
						local exflags = flags
						if n < 3 then
							flags = $|V_SNAPTOTOP
						else
							flags = $|V_SPLITSCREEN
							exflags = $|V_SNAPTOBOTTOM|V_SPLITSCREEN
						end
						if n%2 == 0 then
							flags = $|V_HORZSCREEN
							exflags = $|V_SNAPTORIGHT|V_HORZSCREEN
						else
							exflags = $|V_SNAPTOLEFT
						end
						if daytonakart.hud == WARIOLANDHUD then
							drawWarioLandSplitTimer(v, p, 0, 80, 5, flags)
						elseif daytonakart.hud == WANGANHUD then
							drawWanganTimer(v, p, timertime, flags, false, false, 80, 10, true)
						else
							v.drawString(80, 5, "TIME", flags|V_YELLOWMAP, "center")
							v.drawString(80, 15, timerstring, flags|colflag, "center")
						end
						drawlaps(v, p, n, gamemap, exflags)
					end
				end
			end
		else
			if (p.arcade.timeover and p.arcade.extendflash < 0)
			or (hpmod and hpmod.running and (p.pflags & PF_TIMEOVER)) then
				hud.disable("minimap")
				if not tsrb2kr then
					hud.disable("item")
					hud.disable("rankings")
				end
				if minrankplus then
					if minrankplus.enabled then minrankplus.enabled = false end
				else
					hud.disable("minirankings")
				end
			
				local tic = abs(p.arcade.extendflash)
			
				//TIME
				if tsrb2kr or (compathud.value == 1) or (fndmod and fndmod.active) then
					local flags = V_SNAPTOTOP|V_SNAPTORIGHT|V_MONOSPACE|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH] 
					local timerstring = "0:00"
					local x = 240
					local y = 24
					if (compathud.value == 1) or (fndmod and fndmod.active) then
						y = 14
						if numlaps > 9 then
							if daytonakart.hud ~= WARIOLANDHUD then
								x = 205
							else
								x = 225
							end
						end
					end
					v.drawString(x, y, "TIME", flags|V_YELLOWMAP, "center")
					v.drawString(x, y + 10, timerstring, flags|V_REDMAP, "center")
					if ((daytonakart.hud == BATTLEMANIAHUD) or (daytonakart.hud == WANGANHUD)) and (customspeedometer.value > 0) and (not tsrb2kr) then
						drawBattleManiaSpeed(v, p, V_SNAPTOBOTTOM|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], 42, 152)
					elseif (abs(daytonakart.hud) == LRMAXHUD) and (not tsrb2kr) then
						drawBattleManiaSpeed(v, p, V_SNAPTOBOTTOM|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], 42, 152, true)
					end
					drawDaytonaHP(v, p, V_SNAPTOBOTTOM|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], 160, 197)
				elseif abs(daytonakart.hud) == WANGANHUD then
					drawWanganTimer(v, p, timertime, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					if (customspeedometer.value > 0) then
						drawBattleManiaSpeed(v, p, V_SNAPTOBOTTOM|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], 42, 152)
					end
					if modeattacking then
						drawTATimer(v, p, timertime, 160, 40, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
						drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					end
					drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
				elseif abs(daytonakart.hud) == PIZZATOWERHUD then
					drawFontString(v, "PZRFT", secsToTimer(timertime, false, true), 280, 5, 24, V_SNAPTOTOP|V_SMALLSCALEPATCH|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					if modeattacking then
						drawTATimer(v, p, timertime, 160, 38, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
						drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					end
					drawWarioLandHP(v, p, V_SNAPTOLEFT|V_SNAPTOBOTTOM|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
				elseif daytonakart.hud == WARIOLANDHUD then
					drawWarioLandHP(v, p, V_SNAPTOLEFT|V_SNAPTOBOTTOM|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					drawWarioLandTimer(v, p, timertime, 160, 2, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
				elseif daytonakart.hud == BATTLEMANIAHUD then
					drawBattleManiaSpeedTimer(v, p, timertime, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					drawDaytonaHP(v, p, V_SNAPTOBOTTOM|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], 160, 197)
				elseif daytonakart.hud == TAHUD then
					v.drawString(160, 2, "TIME", V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH]|V_YELLOWMAP, "center")
					drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], REDTEXT)
					drawTATimer(v, p, timertime, 160, 38, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
				elseif daytonakart.hud == (-BATTLEMANIAHUD) then
					drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					drawBattleManiaSpeedTimer(v, p, timertime, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					drawTATimer(v, p, 160, 50, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
				elseif daytonakart.hud == (-WARIOLANDHUD) then
					drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					drawWarioLandTimer(v, p, timertime, 160, 2, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					drawTATimer(v, p, 160, 34, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
				elseif abs(daytonakart.hud) == LRMAXHUD then
					drawLRMAXTimer(v, 160, 5, timertime, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					if modeattacking then
						drawTATimer(v, p, timertime, 160, 40, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
						drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					end
					drawDaytonaHP(v, p, V_SNAPTOBOTTOM|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], 160, 197)
					drawBattleManiaSpeed(v, p, V_SNAPTOBOTTOM|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], 42, 152, true)
				else
					v.drawString(160, 2, "TIME", V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH]|V_YELLOWMAP, "center")
					drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH], REDTEXT)
					drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
				end
				if (customspeedometer.value > 0) and (not tsrb2kr) then 
					if abs(daytonakart.hud) == WARIOLANDHUD or abs(daytonakart.hud) == PIZZATOWERHUD then
						drawWarioLandSpeed(v, p, V_SNAPTOBOTTOM|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					elseif abs(daytonakart.hud) ~= BATTLEMANIAHUD and abs(daytonakart.hud) ~= WANGANHUD and (abs(daytonakart.hud) ~= LRMAXHUD) then
						drawspeed(v, p, 4, 150, V_SNAPTOBOTTOM|V_SNAPTOLEFT|flash[(TIMEOVERLENGTH-tic)*10/TIMEOVERLENGTH])
					end
				end
				
				//TIME OVER
				v.fadeScreen(65280, min(tic / 5, 20))	-- 0xFF00
				if not (hpmod and hpmod.running and (p.pflags & PF_TIMEOVER)) then
					if tic >= (TIMEOVERLENGTH / 4) and tic < ((3 * TIMEOVERLENGTH) / 4) then
						v.draw(160, 100, v.cachePatch("TIMEOVER"), flash[((tic - (TIMEOVERLENGTH / 4))*20)/TIMEOVERLENGTH])
					elseif tic >= ((3 * TIMEOVERLENGTH) / 4) then
						v.draw(160, 100, v.cachePatch("TIMEOVER"))
					end
				end
			
				if not (modeattacking or tsrb2kr) then
					drawplace(v, p, nil, numplayers, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTORIGHT, REDTEXT) //Still shows the final position
				end
			
				
				if modeattacking or (SPLITS and Splits_Runtype()) then
					if endtimer >= (TIMEOVERLENGTH / 4) and endtimer < ((3 * TIMEOVERLENGTH) / 4) then
						v.drawString(160, 118, "RUN OVER - DNF", V_REDMAP|flash[((tic - (TIMEOVERLENGTH / 4))*20)/TIMEOVERLENGTH], "center")
						if modeattacking then
							v.drawString(160, 126, "PLEASE RETRY OR ABORT TO CONTINUE", V_YELLOWMAP|flash[((tic - (TIMEOVERLENGTH / 4))*20)/TIMEOVERLENGTH], "center")
						else
							v.drawString(160, 126, "TRY AGAIN FROM THE START", V_YELLOWMAP|flash[((tic - (TIMEOVERLENGTH / 4))*20)/TIMEOVERLENGTH], "center")
						end
					elseif endtimer >= ((3 * TIMEOVERLENGTH) / 4) then
						v.drawString(160, 118, "RUN OVER - DNF", V_REDMAP, "center")
						if modeattacking then
							v.drawString(160, 126, "PLEASE RETRY OR ABORT TO CONTINUE", V_YELLOWMAP, "center")
						else
							v.drawString(160, 126, "TRY AGAIN FROM THE START", V_YELLOWMAP, "center")
						end
					end
				end
			
			else
				if not tsrb2kr then
					hud.enable("item")
					hud.enable("rankings")
				end
				hud.enable("minimap")

				if not (minrankplus or tsrb2kr) then
					hud.enable("minirankings")
				elseif minrankplus and not (minrankplus.enabled or tsrb2kr) then
					minrankplus.enabled = true
				end
			
				//TIME
				if (((not tsrb2kr) and (compathud.value == 0) or not (fndmod and fndmod.active)) and (abs(daytonakart.hud) ~= LRMAXHUD) and (abs(daytonakart.hud) ~= BATTLEMANIAHUD)) and (daytonakart.hud ~= WANGANHUD) and (daytonakart.hud ~= TAHUD) and (abs(daytonakart.hud) ~= WARIOLANDHUD) and (abs(daytonakart.hud) ~= PIZZATOWERHUD) then
					v.drawString(160, 2, "TIME", V_SNAPTOTOP|V_HUDTRANS|V_YELLOWMAP, "center")
				end
				if (moretime == true) and (not tsrb2kr) and (((compathud.value == 1) or (fndmod and fndmod.active)) and abs(daytonakart.hud) == BATTLEMANIAHUD) then
					v.drawString(60, 159, "+", V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "center")
				elseif moretime == true and (not tsrb2kr) and (compathud.value == 0) and (abs(daytonakart.hud) ~= WANGANHUD) then
					if abs(daytonakart.hud) == LRMAXHUD then
						v.drawString(180, 40, "+", V_SNAPTOTOP|V_HUDTRANS, "center")
					elseif (abs(daytonakart.hud) ~= BATTLEMANIAHUD) then
						v.drawString(178, 12, "+", V_SNAPTOTOP|V_HUDTRANS, "center")
					else
						v.drawString(179, 22, "+", V_SNAPTOTOP|V_HUDTRANS|(((p.arcade.extendflash > 0) and (p.arcade.extendflash % 10) < 5) and V_GREENMAP or V_YELLOWMAP), "center")
					end
				end
				if tsrb2kr or (compathud.value == 1) or (fndmod and fndmod.active) then
					local flags = V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS|V_MONOSPACE
					local addflags = 0
					if p.exiting and not (p.pflags & PF_TIMEOVER) then
						addflags = V_YELLOWMAP
					elseif (p.pflags & PF_TIMEOVER) or not ((timertime > 9) or ((p.realtime % 8) < 4) or (leveltime < TIMEFORONE)) then
						addflags = V_REDMAP
					elseif p.arcade.extendflash > 0 and (p.arcade.extendflash % 8) < 4 then
						addflags = V_GREENMAP
					end
					local timercolon = (((p.realtime % TICRATE) < (TICRATE / 2) or p.exiting) and ":" or " ") 
					local timerstring = secsToTimer(timertime, timercolon)
					
					local x = 235
					local y = 28
					if (compathud.value == 1) or (fndmod and fndmod.active) then
						y = 14
						if numlaps > 9 then
							if daytonakart.hud ~= WARIOLANDHUD then
								x = 205
							else
								x = 225
							end
						end
					end
					v.drawString(x, y, "TIME", flags|V_YELLOWMAP, "center")
					v.drawString(x, y + 10, timerstring, flags|addflags, "center")
					if ((daytonakart.hud == BATTLEMANIAHUD) or (daytonakart.hud == WANGANHUD)) and (not tsrb2kr) then
						drawBattleManiaSpeed(v, p, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT, 42, 152)
					elseif (abs(daytonakart.hud) == LRMAXHUD) and (not tsrb2kr) then
						drawBattleManiaSpeed(v, p, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT, 42, 152, true)
					end
					drawDaytonaHP(v, p, V_SNAPTOBOTTOM|V_HUDTRANS, 160, 197)
				elseif abs(daytonakart.hud) == WANGANHUD then
					drawWanganTimer(v, p, timertime, V_SNAPTOTOP|V_HUDTRANS, moretime)
					if (customspeedometer.value > 0) then
						drawBattleManiaSpeed(v, p, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, 42, 152)
					end
					if modeattacking then
						drawTATimer(v, p, timertime, 160, 40, V_SNAPTOTOP|V_HUDTRANS)
						drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
					end
					drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|V_HUDTRANS)
				elseif abs(daytonakart.hud) == PIZZATOWERHUD then
					local timercolon = (((p.realtime % TICRATE) < (TICRATE / 2) or p.exiting) and true or false) 
					if ((timertime < 60) and (p.realtime % (TICRATE/2)) < (TICRATE / 4)) or (timertime == 0) then
						drawFontString(v, "PZRFT", secsToTimer(timertime, timercolon, true), 280, 5, 24, V_SNAPTOTOP|V_SMALLSCALEPATCH|V_HUDTRANS)
					else
						drawFontString(v, "PIZFT", secsToTimer(timertime, timercolon, true), 280, 5, 24, V_SNAPTOTOP|V_SMALLSCALEPATCH|V_HUDTRANS)
					end
					drawWarioLandHP(v, p, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS)
					if modeattacking then
						drawTATimer(v, p, timertime, 160, 38, V_SNAPTOTOP|V_HUDTRANS)
						drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
					end
				elseif daytonakart.hud == WARIOLANDHUD then
					drawWarioLandHP(v, p, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS)
					drawWarioLandTimer(v, p, timertime, 160, 2, V_SNAPTOTOP|V_HUDTRANS)
					if dkartdebug.enabled then
						v.drawString(2, 2,  "  HP: "..dkartdebug.hp)
						v.drawString(2, 12, "LHP: "..dkartdebug.latent)
						v.drawString(2, 22, "RHP: "..dkartdebug.regen)
					end
				elseif daytonakart.hud == BATTLEMANIAHUD and (compathud.value == 0) then
					drawBattleManiaSpeedTimer(v, p, timertime, V_SNAPTOTOP|V_HUDTRANS)
					drawDaytonaHP(v, p, V_SNAPTOBOTTOM|V_HUDTRANS, 160, 197)
				elseif daytonakart.hud == TAHUD then
					v.drawString(160, 2, "TIME", V_SNAPTOTOP|V_HUDTRANS|V_YELLOWMAP, "center")
					drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS)
					drawTATimer(v, p, timertime, 160, 38, V_SNAPTOTOP|V_HUDTRANS)
					drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
				elseif daytonakart.hud == (-BATTLEMANIAHUD) then
					drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
					drawBattleManiaSpeedTimer(v, p, timertime, V_SNAPTOTOP|V_HUDTRANS)
					drawTATimer(v, p, 160, 50, V_SNAPTOTOP|V_HUDTRANS)
				elseif daytonakart.hud == (-WARIOLANDHUD) then
					drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
					drawWarioLandTimer(v, p, timertime, 160, 2, V_HUDTRANS|V_SNAPTOTOP)
					drawTATimer(v, p, 160, 34, V_SNAPTOTOP|V_HUDTRANS)
				elseif abs(daytonakart.hud) == LRMAXHUD then
					drawLRMAXTimer(v, 160, 5, timertime, V_SNAPTOTOP|V_HUDTRANS)
					if modeattacking then
						drawTATimer(v, p, timertime, 160, 40, V_SNAPTOTOP|V_HUDTRANS)
						drawTAMedalTimes(v, p, 4, 4, V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
					end
					drawBattleManiaSpeed(v, p, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT, 42, 152, true)
					drawDaytonaHP(v, p, V_SNAPTOBOTTOM|V_HUDTRANS, 160, 197)
				elseif p.exiting or (server.SPBArunning and (server.SPBAdone or server.SPBAwin)) then
					if (p.kartstuff[k_position] == 1) or server.SPBAwin then
						drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS, YELLOWTEXT) //Yellow
					elseif (p.pflags & PF_TIMEOVER) or server.SPBAdone then
						drawTimer(v, 0, 160, 10, V_SNAPTOTOP|V_HUDTRANS, REDTEXT) //Red	
					elseif K_IsPlayerLosing(p) then
						drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS) //White
					else
						drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS, GREENTEXT) //Green
					end
					drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|V_HUDTRANS)
				elseif server.SPBArunning and leveltime >= TIMEFORGO then
					if ((p.realtime % 8) < 4) then
						drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS, REDTEXT)
					else
						drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS, YELLOWTEXT)
					end
					drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|V_HUDTRANS)
				elseif p.arcade.extendflash > 0 and (p.arcade.extendflash % 8) < 4 then
					drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS, GREENTEXT) //Green
					drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|V_HUDTRANS)
				elseif (timertime > 9) or ((p.realtime % 8) < 4) or (leveltime < TIMEFORONE) then
					drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS) //White
					drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|V_HUDTRANS)
				else
					drawTimer(v, timertime, 160, 10, V_SNAPTOTOP|V_HUDTRANS, REDTEXT) //Red	
					drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|V_HUDTRANS)
				end
				if (not tsrb2kr) then
					local txstr
					local stringmap = 0
					
					if server.SPBArunning then
						txstr = "KEEP ON RUNNING..."
						stringmap = V_REDMAP
					elseif mapheaderinfo[gamemap].noextension or mapheaderinfo[gamemap].arcadeboss then
						txstr = "NO TIME EXTENSIONS!"
						stringmap = V_REDMAP
					else
						txstr = "TIME EXTENDED!"
					end
					
					if p.arcade.extendflash > 0 and (p.arcade.extendflash % 10) < 5 and (not tsrb2kr) then
						if (compathud.value == 1) or (fndmod and fndmod.active) then
							v.drawString(160, 50, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						elseif (daytonakart.hud == WARIOLANDHUD) or (daytonakart.hud == PIZZATOWERHUD) then
							v.drawString(160, 34, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						elseif daytonakart.hud == BATTLEMANIAHUD then
							v.drawString(160, 53, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						elseif (daytonakart.hud == (-WARIOLANDHUD)) or (daytonakart.hud == (-PIZZATOWERHUD)) then
							v.drawString(160, 44, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						elseif daytonakart.hud == (-BATTLEMANIAHUD) then
							v.drawString(160, 63, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						elseif (daytonakart.hud == WANGANHUD) or (daytonakart.hud == LRMAXHUD) then
							v.drawString(160, 40, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						elseif (daytonakart.hud == (-WANGANHUD)) or (daytonakart.hud == (-LRMAXHUD)) then
							v.drawString(160, 50, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						elseif daytonakart.hud == TAHUD then
							v.drawString(160, 48, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						else
							v.drawString(160, 38, txstr, V_SNAPTOTOP|V_HUDTRANS|stringmap, "center")
						end
					end
					drawlaps(v, p, nil, gamemap, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP)
			
					//Speedometer
					if (customspeedometer.value > 0) then 
						if abs(daytonakart.hud) == 2 or abs(daytonakart.hud) == 4 then
							drawWarioLandSpeed(v, p, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
						elseif (compathud.value == 1 and (daytonakart.hud ~= BATTLEMANIAHUD) and (abs(daytonakart.hud) ~= LRMAXHUD)) or (fndmod and fndmod.active and (abs(daytonakart.hud) ~= LRMAXHUD) and daytonakart.hud ~= BATTLEMANIAHUD) then
							drawspeed(v, p, 4, 150, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
						end
					end
				end
			
				//Placement
				if not (modeattacking or tsrb2kr) then
					local lapstogo = numlaps - p.laps
					if mapheaderinfo[gamemap].lapcheckpoints ~= nil and lapstogo > 0 then
						lapstogo = (numlaps/mapheaderinfo[gamemap].lapcheckpoints) - p.arcade.numlaps
					end
				
					local colour = nil
				
					if lapstogo == 0 then //FINISH!
						if p.kartstuff[k_position] == 1 then
							colour = YELLOWTEXT
						elseif K_IsPlayerLosing(p) then //Red
							colour = REDTEXT
						else //Green
							colour = GREENTEXT
						end
					elseif lapstogo == 1 and (p.realtime % 12) < 6 then //Final lap!
						if K_IsPlayerLosing(p) then //Flash Red
							colour = REDTEXT
						else //Flash Green
							colour = GREENTEXT
						end
					end
				
					if colour ~= nil then
						drawplace(v, p, nil, numplayers, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTORIGHT, colour)
					else
						drawplace(v, p, nil, numplayers, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTORIGHT)
					end
				end
			end
		end
		if showdiff.value == 1 then
			local difficultytext = ({
				[69] = "Custom Difficulty",
				[30] = "N00B Level",
				[15] = "Beginner",
				[0] = "Standard",
				[-5] = "Advanced",
				[-10] = "Expert",
				[-20] = "Master"
			}) [daytonakart.diff]
			if daytonakart.lrmax then
				if daytonakart.diff == 69 then difficultytext = "LunarRay" end
				difficultytext = $ .. "/MAX"
			end
			v.drawString(160, 192, difficultytext, V_ALLOWLOWERCASE|V_70TRANS|V_SNAPTOBOTTOM, "center")
		end
	elseif (gametype & GT_MATCH) and (not p.spectator) and (p.arcade != nil) and daytonakart.active then
		hud.disable("gametypeinfo") //Done custom
		hud.disable("speedometer") //Also done custom
		hud.enable("item") --Not done custom
		hud.enable("rankings") --ditto
		hud.enable("position") --ditto again
		if not (minrankplus or tsrb2kr) then
			hud.enable("minirankings")
		elseif minrankplus and not (minrankplus.enabled or tsrb2kr) then
			minrankplus.enabled = true
		end
		if splitscreen then
			local n = c.pnum
			if not n then return end
			local flags = V_HUDTRANS|V_MONOSPACE
			local col
			local colflag = 0
			local timertime
			local timeheld = false
			local inftime = false
			if p.arcade.timelimit > 0 then
				timertime = max(0, (p.arcade.timelimit - p.realtime) / 35)
			elseif daytonakart.firstblood.enabled then
				timertime = daytonakart.firstblood.timelim / 35
				timeheld = true
			else
				timertime = p.realtime / 35
				inftime = true
			end
			local timercolon = (((p.realtime % TICRATE) < (TICRATE / 2) or p.exiting) and true or false) 
			local timerstring = secsToTimer(timertime, timercolon)
			if not ((timertime > 9) or ((p.realtime % 8) < 4) or (leveltime < TIMEFORONE))
				and ((p.arcade.timelimit > 0) or daytonakart.firstblood.enabled) then
				col = REDTEXT
				colflag = V_REDMAP
			end
			if splitscreen == 1 then
				local barflags = flags
				local y = 80
				if n == 2 then 
					flags = $|V_SPLITSCREEN
					barflags = $|V_SNAPTOBOTTOM
					y = 180
				else
					flags = $|V_SNAPTOTOP
				end
				if daytonakart.hud == WARIOLANDHUD then
					drawWarioLandSplitTimer(v, p, timertime, 160, 5, flags)
				elseif daytonakart.hud == WANGANHUD then
					drawWanganTimer(v, p, timertime, flags, timeheld, inftime, nil, 10, true)
				else
					v.drawString(160, 5, "TIME", flags|V_YELLOWMAP, "center")
					v.drawString(160, 15, timerstring, flags|colflag, "center")
				end
				if (daytonakart.hud == BATTLEMANIAHUD) or (daytonakart.hud == DAYTONAHUD) then
					drawDaytonaHP(v, p, barflags, 160, y + 17)
				elseif (daytonakart.hud == WARIOLANDHUD) then
					drawWarioLandHP(v, p, V_SNAPTOLEFT|barflags, nil, y - 20)
				else
					drawWanganSPBars(v, p, false, false, nil, y, barflags)
				end
			else
				local barflags = flags
				local y
				if n < 3 then
					flags = $|V_SNAPTOTOP
					y = 80 
				else
					flags = $|V_SPLITSCREEN
					barflags = $|V_SNAPTOBOTTOM
					y = 180
				end
				if n%2 == 0 then
					flags = $|V_HORZSCREEN
					barflags = $|V_HORZSCREEN
					if not ((daytonakart.hud == BATTLEMANIAHUD) or (daytonakart.hud == DAYTONAHUD)) then
						drawWanganSPBars(v, p, false, true, 105, y, barflags)
					end
				elseif not ((daytonakart.hud == BATTLEMANIAHUD) or (daytonakart.hud == DAYTONAHUD)) then
					drawWanganSPBars(v, p, true, true, 55, y, barflags)
				end
				if daytonakart.hud == WARIOLANDHUD then
					drawWarioLandSplitTimer(v, p, timertime, 80, 5, flags)
				elseif daytonakart.hud == WANGANHUD then
					drawWanganTimer(v, p, timertime, flags, timeheld, inftime, 80, 10, true)
				else
					v.drawString(80, 5, "TIME", flags|V_YELLOWMAP, "center")
					v.drawString(80, 15, timerstring, flags|colflag, "center")
				end
				if (daytonakart.hud == BATTLEMANIAHUD) or (daytonakart.hud == DAYTONAHUD) then
					drawDaytonaHP(v, p, barflags, 80, y + 17)
				end
			end
		elseif (compathud.value == 0) and not (fndmod and fndmod.active) then
			hud.disable("time") //Done custom
			
			if daytonakart.hud == WANGANHUD then
				if p.arcade.timelimit > 0 then
					local timertime = max(0, (p.arcade.timelimit - p.realtime) / 35)
					drawWanganTimer(v, p, timertime, V_SNAPTOTOP|V_HUDTRANS)
				elseif daytonakart.firstblood.enabled then
					local timertime = daytonakart.firstblood.timelim / 35
					drawWanganTimer(v, p, timertime, V_SNAPTOTOP|V_HUDTRANS, true)
				else
					drawWanganTimer(v, p, 0, V_SNAPTOTOP|V_HUDTRANS, false, true)
				end
				if (customspeedometer.value > 0) then
					drawBattleManiaSpeed(v, p, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS, 42, 152)
				end
				drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|V_HUDTRANS)
			elseif not ((daytonakart.hud == WARIOLANDHUD) or (daytonakart.hud == PIZZATOWERHUD)) then
				if p.arcade.timelimit > 0 then
					local timertime = max(0, (p.arcade.timelimit - p.realtime) / 35)
					drawBattleManiaSpeedTimer(v, p, timertime, V_SNAPTOTOP|V_HUDTRANS)
				elseif daytonakart.firstblood.enabled then
					local timertime = daytonakart.firstblood.timelim / 35
					drawBattleManiaSpeedTimer(v, p, timertime, V_SNAPTOTOP|V_HUDTRANS)
				else
					drawBattleManiaSpeedTimer(v, p, 0, V_SNAPTOTOP|V_HUDTRANS, nil, nil, true)
				end
				drawDaytonaHP(v, p, V_SNAPTOBOTTOM|V_HUDTRANS, 160, 197)
			else
				local timertime
				if p.arcade.timelimit > 0 then
					timertime = max(0, (p.arcade.timelimit - p.realtime) / 35)
					if ((((p.arcade.timelimit - p.realtime) / 35) > 0) or ((p.arcade.timelimit > p.realtime) and (p.arcade.timelimit < (p.realtime + 35)))) and (leveltime > (TIMEFORGO+1)) then 
						timertime = $ + 1
					end
					if (daytonakart.hud == WARIOLANDHUD) then
						drawWarioLandTimer(v, p, timertime, 160, 2, V_HUDTRANS|V_SNAPTOTOP)
					else
						local timercolon = (((p.realtime % TICRATE) < (TICRATE / 2) or p.exiting) and true or false) 
						if ((timertime < 60) and (p.realtime % (TICRATE/2)) < (TICRATE / 4)) or (timertime == 0) then
							drawFontString(v, "PZRFT", secsToTimer(timertime, timercolon, true), 280, 5, 24, V_SNAPTOTOP|V_SMALLSCALEPATCH|V_HUDTRANS)
						else
							drawFontString(v, "PIZFT", secsToTimer(timertime, timercolon, true), 280, 5, 24, V_SNAPTOTOP|V_SMALLSCALEPATCH|V_HUDTRANS)
						end
					end
				else
					if daytonakart.firstblood.enabled then
						timertime = daytonakart.firstblood.timelim / 35
					else
						timertime = p.realtime/TICRATE
					end
					if (daytonakart.hud == WARIOLANDHUD) then
						drawWarioLandTimer(v, p, timertime, 160, 2, V_HUDTRANS|V_SNAPTOTOP, true)
					else
						local timercolon = (((p.realtime % TICRATE) < (TICRATE / 2) or p.exiting or (daytonakart.firstblood.enabled and not daytonakart.firstblood.blooddrawn)) and true or false) 
						drawFontString(v, "PIZFT", secsToTimer(timertime, timercolon, true), 280, 5, 24, V_SNAPTOTOP|V_SMALLSCALEPATCH|V_HUDTRANS)
					end
				end
				drawWarioLandHP(v, p, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS)
				drawWarioLandSpeed(v, p, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			end
			if p.arcade.extendflash > 0 and (p.arcade.extendflash % 10) < 5 then
				if (daytonakart.hud == WARIOLANDHUD) or (daytonakart.hud == PIZZATOWERHUD) then
					v.drawString(160, 34, "FIRST BLOOD IS DRAWN!", V_SNAPTOTOP|V_HUDTRANS|V_REDMAP, "center")
				elseif daytonakart.hud == WANGANHUD
					v.drawString(160, 40, "FIRST BLOOD IS DRAWN!", V_SNAPTOTOP|V_HUDTRANS|V_REDMAP, "center")
				else
					v.drawString(160, 53, "FIRST BLOOD IS DRAWN!", V_SNAPTOTOP|V_HUDTRANS|V_REDMAP, "center")
				end
			end
		else
			hud.enable("time")
			if daytonakart.hud == WANGANHUD then
				drawBattleManiaSpeed(v, p, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT, 42, 152)
				drawWanganSPBars(v, p, false, false, nil, nil, V_SNAPTOBOTTOM|V_HUDTRANS)
			elseif not ((daytonakart.hud == WARIOLANDHUD) or (daytonakart.hud == PIZZATOWERHUD)) then
				drawBattleManiaSpeed(v, p, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT, 42, 152)
				drawDaytonaHP(v, p, V_SNAPTOBOTTOM|V_HUDTRANS, 160, 197)
			else
				drawWarioLandHP(v, p, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS)
				drawWarioLandSpeed(v, p, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			end
			if p.arcade.extendflash > 0 and (p.arcade.extendflash % 10) < 5 then
				v.drawString(160, 90, "FIRST BLOOD IS DRAWN!", V_SNAPTOTOP|V_HUDTRANS|V_REDMAP, "center")
				v.drawString(160, 100, daytonakart.firstblood.timelim/TICRATE .. "s UNTIL ROUND ENDS!", V_SNAPTOTOP|V_HUDTRANS|V_REDMAP, "center")
			end
		end
	else
		if not tsrb2kr then
			hud.enable("time")
			hud.enable("item")
			hud.enable("position")
			hud.enable("speedometer")
			hud.enable("rankings")
		end
		
		hud.enable("minimap")
		
		
		if not (tsrb2kr or (hpmod and hpmod.running and G_BattleGametype())) then
			hud.enable("gametypeinfo")
		end
		
		if not (tsrb2kr or minrankplus) then
			hud.enable("minirankings")
		elseif minrankplus and not (minrankplus.enabled or tsrb2kr) then
			minrankplus.enabled = true
		end
		
		hud.enable("freeplay")
	end
end, "game")

hud.add(function(v)
	if not daytonakart.active then return end
	if not (gametype & GT_MATCH) then
		local difficultytext = ({
			[69] = "Custom difficulty",
			[30] = "N00B Level",
			[15] = "Beginner",
			[0] = "Standard",
			[-5] = "Advanced",
			[-10] = "Expert",
			[-20] = "Master"
		}) [daytonakart.diff]
		if daytonakart.lrmax then
			if daytonakart.diff == 69 then difficultytext = "LunarRay" end
			difficultytext = $ .. "/MAX"
		end
		v.drawString(0, 192, difficultytext, V_ALLOWLOWERCASE|V_40TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
	if daytonakart.lrmax then
		v.draw(318, 198, v.cachePatch("LRUSAXRD"), V_40TRANS|V_SNAPTOBOTTOM|V_SNAPTORIGHT)
	else
		v.drawString(320, 192, "Daytona Kart: "..version.." ", V_ALLOWLOWERCASE|V_40TRANS|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "right")
	end
end, "scores")

print("\x82".."Daytona Kart "..version.." is now installed!")

COM_AddCommand("daytonaHelp", function(p)
	CONS_Printf(p, "\x82".."arcade_speed: Determines what speedometer type to use. Default Miles.")
	CONS_Printf(p, "\x82".."Options - Disabled, Miles, Kilometers, Meters, Fracunits, Knots, Feet.")
	CONS_Printf(p, "\x82".."arcade_tenthspeed: Shows or hides the tenths of the speed. Default On.")
	CONS_Printf(p, "\x82".."arcade_capto99: Caps the shown time limit to 99. Default Off.")
	CONS_Printf(p, "\x82".."arcade_placezero: Shows a leading zero in 10+ player races. Default Off.")
	CONS_Printf(p, "\x82".."arcade_instupdate: Does the timer insta-updates, or over time? Default On.")
	CONS_Printf(p, "\x82".."arcade_hud: Determines the HUD type. Default BattleMania.")
	CONS_Printf(p, "\x82".."arcade_showdiff: Displays the difficulty level at the bottom of the screen. Default Off.")
end)

COM_AddCommand("daytonaServerHelp", function(p)
	CONS_Printf(p, "\x82".."arcade: Toggles Arcade Mode on and off. Default On.")
	CONS_Printf(p, "\x82".."arcade_diff: Determines the modifiers for the time limit.")
	CONS_Printf(p, "\x82".."Easiest - 30% extra. Easy - 15% extra. Normal (Default) - default.")
	CONS_Printf(p, "\x82".."Hard - 5s less starting time, 2s less bonus time.")
	CONS_Printf(p, "\x82".."Expert - 10s less starting time, 5s less bonus time.")
	CONS_Printf(p, "\x82".."Master - 20s less starting time, 5s less bonus time.")
	CONS_Printf(p, "\x82".."Custom - Customized time modificaions..")
	CONS_Printf(p, "\x82".."arcade_sneaker: Limits items to (mainly) Sneakers. Default Off.")
	CONS_Printf(p, "\x82".."arcade_compathud: Compacts the HUD for certain mods. Default Off.")
end, 1)