local loaded
local PATH = "daytonakart.cfg"
local modname = "Daytona Kart"

local function loadconfig()
	if not loaded then
		local file = io.open(PATH, "r")
		if file == nil then
			file = io.open(PATH, "w")
			if not file then
				print("A "..modname.." config couldn't be generated. Write permission issues?")
				print("[If you're seeing this in your dedi's server console, this is fine.]")
				loaded = true
			end
			print("\130A "..modname.." config was created in luafiles/"..PATH..".")
			print("\130Commands placed there will run when you join a server using "..modname..".")
			file:write("arcade_speed Miles".."\n")
			file:write("arcade_tenthspeed on".."\n")
			file:write("arcade_capto99 off".."\n")
			file:write("arcade_placezero off".."\n")
			file:write("arcade_instupdate on".."\n")
			file:write("arcade_hud BattleMania".."\n")
			
			file:close()
		else
			if not consoleplayer then
				print("Tried to read "..PATH..", but there's no player to execute it with.")
				print("[If you're seeing this in your dedi's server console, this is fine.]")
				loaded = true
				return
			end
			print("\130A "..modname.." config was found. Loading, sit tight...")
			local buf = file:read()
			while buf
				COM_BufInsertText(consoleplayer, buf)
				buf = file:read()
			end
			file:close()
		end
		loaded = true
	end
end

addHook("ThinkFrame", loadconfig)
addHook("IntermissionThinker", loadconfig)
addHook("VoteThinker", loadconfig)